/**************************************************************************************************
For use with Climbing Maps
http://www.kreedz.com/
And Other Climbing Maps

List Maps & Configurations in climbing.ini


**** CVARS (FEATURES) ****
kz_autoheal    = AutoHeal
kz_autospawn   = AutoSpawn
kz_bunnyjump   = 1 = No slowdown after jumping | 2 = Just hold down jump to bunny hop
kz_godmode     = AutoGodmode
kz_semiclip    = AutoSemiClip
kz_scout       = AutoScout
kz_nightvision = Free NVG
kz_nightmode   = Nightmode
kz_checkpoints = Checkpoints 
kz_timer       = IndividualTimer
kz_top15       = Top15 (BETA)

**** CVARS (CHECKPOINT SYSTEM) ****
kz_checkprice		 = Price of a checkpoint
kz_checkpointdist = Distance from other people you can spawn
kz_checkeffects	 = Some cool teleport effects
kz_limitedcp			= Limit each checkpoint to one use
kz_startmoney		 = Instead of mp_startmoney

**** CVARS (OTHER) ****
sv_grabforce "8" = Grabforce for JediGrab

**** ADMIN COMMANDS ****

ADMIN_LEVEL_A (flag="m")
Set Checkpoint			= amx_checkpoint <name|#userid|authid> [x] [y] [z] - sets checkpoint
Rem Checkpoint			= amx_remcheckpoint <name|#userid|authid> - removes checkpoint
Setting Origin			= amx_teleport <name|#userid|authid> [x] [y] [z] - teleports
Getting Origin			= amx_userorigin <name|#userid|authid> - displays position
Setting Semiclip		= amx_semiclip <name|#userid|authid|@TEAM|*(all)> <0|1> - removes/gives semiclip
Giving Longjump		= amx_longjump <name|#userid|authid|@TEAM|*(all)> - gives a LongJump
Giving Scout			= amx_scout <name|#userid|authid|@TEAM|*(all)> - gives a Steyr Scout
Giving Money			= amx_money <name|#userid|authid|@TEAM|*(all)> <money> - gives/removes money
Setting Glow	     	= amx_glow <name|#userid|authid|@TEAM|*(all)> <color|invisible|normal> [alpha] - makes glow/unglow
Setting Gravity		= amx_gravity <name|#userid|authid|@TEAM|*(all)> <gravity|normal> - changes gravity

ADMIN_LEVEL_B (flag="n")
Setting Godmode		= amx_godmode <name|#userid|authid|@TEAM|*(all)> <0|1> - removes/gives godmode
Setting Noclip			= amx_noclip <name|#userid|authid|@TEAM|*(all)> <0|1> - removes/gives noclip

ADMIN_LEVEL_D (flag="p")
Jedi Force Grab by Spacedude (slightly modified)
Grabbing a person		= +grab - grabs a player you aiming (bind a key to ^"+grab^")
Releasing grabbed		= -grab - ungrabs the player you aim
Toggle Command			= grab_toggle - press once to grab and again to release a player

ADMIN_LEVEL_E (flag="q") || Granted by admin
Granting Hook/Rope	     = amx_granthook <name|#userid|authid|@TEAM|*(all)> <0|1> - removes/gives granthook powers
Attaching Rope			= +rope - throws a rope (bind a key to ^"+rope^")
Deattaching Rope		= -rope - unthrows the rope
Attaching Hook			= +hook - throws a hook (bind a key to ^"+hook^")
Deattaching Hook		= -hook - unthrows the hook

**** USER COMMANDS ****

Buy a checkpoint	= checkpoint - buys a checkpoint
Buy a checkpoint	= say /checkpoint- buys a checkpoint
Go the checkpoint	= gocheck - moves you to your checkpoint previously saved
Go the checkpoint	= say /gocheck - moves you to your checkpoint previously saved
Unstuck yourself	= say /stuck - unstucks you or go back to the last checkpoint
Unstuck yourself	= say /unstuck - unstucks you or go back to the last checkpoint
Display KZ top15	= say /kztop15 - displays KZ top15 (MOTD)

**************************************************************************************************/

/******************************************************************************/
// If you change one of the following settings, do not forget to recompile
// the plugin and to install the new .amx file on your server.
// You can find the list of admin flags in the amx/examples/include/amxconst.inc file.

// Admin commands
#define FLAG_AMX_CHECKPOINT    ADMIN_LEVEL_A
#define FLAG_AMX_REMCHECKPOINT ADMIN_LEVEL_A

#define FLAG_AMX_TELEPORT   ADMIN_LEVEL_A
#define FLAG_AMX_USERORIGIN ADMIN_LEVEL_A
#define FLAG_AMX_SEMICLIP   ADMIN_LEVEL_A
#define FLAG_AMX_LONGJUMP   ADMIN_LEVEL_A
#define FLAG_AMX_SCOUT      ADMIN_LEVEL_A
#define FLAG_AMX_MONEY      ADMIN_LEVEL_A
#define FLAG_AMX_GLOW       ADMIN_LEVEL_A
#define FLAG_AMX_GRAVITY    ADMIN_LEVEL_A
#define FLAG_AMX_GODMODE    ADMIN_LEVEL_B
#define FLAG_AMX_NOCLIP     ADMIN_LEVEL_B

#define FLAG_GRAB           ADMIN_LEVEL_D
#define FLAG_AMX_GRANTHOOK  ADMIN_LEVEL_E
#define FLAG_HOOK           ADMIN_LEVEL_E

// Player commands
#define FLAG_CHECKPOINT         ADMIN_ALL
#define FLAG_GOCHECK            ADMIN_ALL
#define FLAG_SAY_LASTCHECKPOINT ADMIN_ALL
#define FLAG_SAY_KZTOP15        ADMIN_ALL

// Uncomment the following line to force the NO_STEAM support for this plugin (CS 1.5).
//#define NO_STEAM

// Uncomment the following line to enable the AMX logs for this plugin.
//#define USE_LOGS

// Uncomment to activate the automatic removal of usps and scouts.
//#define USP_SCOUT_KILL

/******************************************************************************/

#include <translator>
#include <amxmod>
#include <amxmisc>
#include <cstrike>
#include <fun>

#define TE_BEAMENTPOINT 1
#define TE_KILLBEAM 99
#define DELTA_T 0.1				// seconds
#define BEAMLIFE 100			// deciseconds
#define MOVEACCELERATION 150	// units per second^2
#define REELSPEED 300			// units per second

/* Stuff */
new gClimbMap
new NVGrun[33]
new Cvar[4] // mp_friendlyfire, mp_autoteambalance, mp_limitteams, mp_flashlight
new gMoney[33]
new gJoined[33]
new gStartMoney
new gConfigFile[128]
new gScorePath[128]
new gMaxPlayers

/* Checkpoint Stuff */
new bool:gCheckpoint[33]
new gCheckpointPos[33][3]
new gLastCheckpointPos[33][3]

/* Hook Stuff */
new gHookLocation[33][3]
new gHookLenght[33]
new bool:gIsHooked[33]
new gAllowedHook[33]
new Float:gBeamIsCreated[33]
new global_gravity
new beam

/* Timer Stuff */
new bool:gHasTimer[33],bool:gHasStoppedTimer[33]
new gSecs[33], gMins[33], gHuns[33], gChecks[33]

/* Top15 Stuff */
new gNameScore[15][33]
new gAuthScore[15][24]
new gMinsScore[15]
new gSecsScore[15]
new gHunsScore[15]
new gChecksScore[15]

/* Misc Stuff (from the update) */
#if !defined charsmax
	#define charsmax(%1) sizeof(%1) - 1
#endif

#define IsPlayer(%1) (1 <= %1 <= gMaxPlayers)

new gIsFuncButton[44]
#define SetEntBits(%1)    gIsFuncButton[%1>>5] |= (1<<(%1-1))
#define RemoveEntBits(%1) gIsFuncButton[%1>>5] &= ~(1<<(%1-1))
#define GetEntBits(%1)   (gIsFuncButton[%1>>5] & (1<<(%1-1)))

new bool:gConnected[33]
new bool:gAlive[33]

new gTimerThinker
#define TIMER_THINK_TIME 0.1

new gMapName[32]

new grabmodeon

new g_cvar_kz_autoheal
new g_cvar_kz_autospawn
new g_cvar_kz_bunnyjump
new g_cvar_kz_godmode
new g_cvar_kz_semiclip
new g_cvar_kz_scout
new g_cvar_kz_nightvision
new g_cvar_kz_nightmode
new g_cvar_kz_checkpoints
new g_cvar_kz_timer
new g_cvar_kz_top15

new g_cvar_kz_checkprice
new g_cvar_kz_checkpointdist
new g_cvar_kz_checkeffects
new g_cvar_kz_limitedcp
new g_cvar_kz_startmoney

new g_cvar_sv_gravity

new g_cvar_sv_grabforce

/************************************************************************************************************************/
public plugin_precache()
{
	precache_sound("items/nvg_on.wav") 
	precache_sound("items/nvg_off.wav")
	precache_sound("fvox/powermove_on.wav")

	beam = precache_model("sprites/zbeam4.spr")
	precache_sound("weapons/xbow_hit2.wav")
}
/************************************************************************************************************************/
public plugin_init() //Called on plugin start
{
	// Plugin Info
	load_translations("kz_multiplugin")
	register_plugin(_T("KZ Multiplugin"),"2.1","AssKicR")

	//CVARS
	g_cvar_kz_autoheal = register_cvar("kz_autoheal","0")
	g_cvar_kz_autospawn = register_cvar("kz_autospawn","0")
	g_cvar_kz_bunnyjump = register_cvar("kz_bunnyjump","0")
	g_cvar_kz_godmode = register_cvar("kz_godmode","0")
	g_cvar_kz_semiclip = register_cvar("kz_semiclip","0")
	g_cvar_kz_scout = register_cvar("kz_scout","0")
	g_cvar_kz_nightvision = register_cvar("kz_nightvision","0")
	g_cvar_kz_nightmode = register_cvar("kz_nightmode","0")
	g_cvar_kz_checkpoints = register_cvar("kz_checkpoints","0")
	g_cvar_kz_timer = register_cvar("kz_timer","1")
	g_cvar_kz_top15 = register_cvar("kz_top15", "0")

	g_cvar_kz_checkprice = register_cvar("kz_checkprice","500")
	g_cvar_kz_checkpointdist = register_cvar("kz_checkpointdist","50")
	g_cvar_kz_checkeffects = register_cvar("kz_checkeffects","0")
	g_cvar_kz_limitedcp = register_cvar("kz_limitedcp","0")
	g_cvar_kz_startmoney = register_cvar("kz_startmoney","16000")
	
	g_cvar_sv_gravity = get_cvar_pointer("sv_gravity")
	
	build_path(gConfigFile,sizeof(gConfigFile),"$configdir/climbing.ini")
	build_path(gScorePath,sizeof(gScorePath),"$basedir/kz_top15")
	
	if((gClimbMap = ClimbMap())) {
		gStartMoney = get_cvarptr_num(g_cvar_kz_startmoney)

		//EVENTS
		register_event("DeathMsg", "DeathMsg", "a")
		register_event("Damage", "Damage", "b", "2!0")
		register_event("ResetHUD", "ResetHUD", "be")
		register_event("TextMsg","RestartRound","a","2&#Game_C","2&#Game_w")

		//CLIENT CMDS
		#if defined USP_SCOUT_KILL
		register_clcmd("drop", "drop_weapons")
		#endif
		register_clcmd("nightvision","NVGToggle")

		//CHECKPOINT CMDS
		register_clcmd("checkpoint","Checkpoint", FLAG_CHECKPOINT, _T("- buys a checkpoint"))
		register_clcmd("say /checkpoint","Checkpoint", FLAG_CHECKPOINT, _T("- buys a checkpoint"))

		register_clcmd("gocheck","GoCheckpoint", FLAG_GOCHECK, _T("- moves you to your checkpoint previously saved"))
		register_clcmd("say /gocheck","GoCheckpoint", FLAG_GOCHECK, _T("- moves you to your checkpoint previously saved"))

		register_clcmd("say /stuck","LastCheckpoint", FLAG_SAY_LASTCHECKPOINT, _T("- unstucks you or go back to the last checkpoint"))
		register_clcmd("say /unstuck","LastCheckpoint", FLAG_SAY_LASTCHECKPOINT, _T("- unstucks you or go back to the last checkpoint"))

		//KZ TOP15
		register_clcmd("say /kztop15", "show_top15", FLAG_SAY_KZTOP15, _T("- displays KZ top15 (MOTD)"))

		register_clcmd("radio1","blocked")
		register_clcmd("radio2","blocked")
		register_clcmd("radio3","blocked")

		//ADMIN CMDS
		register_concmd("amx_checkpoint","cmdSetCheck",FLAG_AMX_CHECKPOINT,_T("<name|#userid|authid> [x] [y] [z] - sets checkpoint"))
		register_concmd("amx_remcheckpoint","cmdRemCheck",FLAG_AMX_REMCHECKPOINT,_T("<name|#userid|authid> - removes checkpoint"))
		register_concmd("amx_semiclip","cmdSemiClip",FLAG_AMX_SEMICLIP,_T("<name|#userid|authid|@TEAM|*(all)> <0|1> - removes/gives semiclip"))
		register_concmd("amx_granthook","cmdGrantHook",FLAG_AMX_GRANTHOOK,_T("<name|#userid|authid|@TEAM|*(all)> <0|1> - removes/gives granthook powers"))
		register_concmd("amx_longjump","cmdLongJump",FLAG_AMX_LONGJUMP,_T("<name|#userid|authid|@TEAM|*(all)> - gives a LongJump"))
		register_concmd("amx_scout","cmdScout",FLAG_AMX_SCOUT,_T("<name|#userid|authid|@TEAM|*(all)> - gives a Steyr Scout"))

		register_clcmd("+rope", "hook_on",FLAG_HOOK,_T("- throws a rope (bind a key to ^"+rope^")"))
		register_clcmd("-rope", "hook_off",FLAG_HOOK,_T("- unthrows the rope"))
		register_clcmd("+hook", "hook_on",FLAG_HOOK,_T("- throws a hook (bind a key to ^"+hook^")"))
		register_clcmd("-hook", "hook_off",FLAG_HOOK,_T("- unthrows the hook"))

		//CVAR ENFORCING
		Cvar[0] = get_cvar_num("mp_friendlyfire")
		Cvar[1] = get_cvar_num("mp_autoteambalance")
		Cvar[2] = get_cvar_num("mp_limitteams")
		Cvar[3] = get_cvar_num("mp_flashlight")
		set_cvar_num("mp_friendlyfire",0)
		set_cvar_num("mp_autoteambalance",0)
		set_cvar_num("mp_limitteams",0)
		set_cvar_num("mp_flashlight",1)

		if((gTimerThinker = create_entity("info_target")) > 0) {
			entity_set_float(gTimerThinker, EV_FL_nextthink, get_gametime() + TIMER_THINK_TIME)
			entity_set_string(gTimerThinker, EV_SZ_classname, "kz_timer_thinker")
		}

		gMaxPlayers = get_maxplayers()

		read_top15()

		new ent = -1
		while((ent = find_entity(ent, "func_button")) > 0) {
			SetEntBits(ent)
		}
	}
}
/************************************************************************************************************************/
public plugin_cfg() { //Called on plugin cfg
	if(gClimbMap) {
		if(!is_plugin_running("admin_allinone.amx")) {
			if(!is_plugin_running("admin_glow.amx")) {
				register_concmd("amx_glow", "cmdGlow", FLAG_AMX_GLOW,_T("<name|#userid|authid|@TEAM|*(all)> <color|invisible|normal> [alpha] - makes glow/unglow"))
			}
			if(!is_plugin_running("admin_godmode.amx")) {
				register_concmd("amx_godmode", "cmdGodmode",FLAG_AMX_GODMODE,_T("<name|#userid|authid|@TEAM|*(all)> <0|1> - removes/gives godmode"))
			}
			if(!is_plugin_running("admin_gravity.amx")) {
				register_concmd("amx_gravity", "cmdGravity", FLAG_AMX_GRAVITY,_T("<name|#userid|authid|@TEAM|*(all)> <gravity|normal> - changes gravity"))
			}
			if(!(is_plugin_running("admin_money.amx") || is_plugin_running("unlimited_money.amx"))) {
				register_concmd("amx_money", "cmdMoney", FLAG_AMX_MONEY, _T("<name|#userid|authid|@TEAM|*(all)> <money> - gives/removes money"))
			}
			if(!is_plugin_running("admin_noclip.amx")) {
				register_concmd("amx_noclip", "cmdNoclip", FLAG_AMX_NOCLIP, _T("<name|#userid|authid|@TEAM|*(all)> <0|1> - removes/gives noclip"))
			}
			if(!is_plugin_running("admin_teleport.amx")) {
				register_concmd("amx_teleport", "cmdTeleport", FLAG_AMX_TELEPORT, _T("<name|#userid|authid> [x] [y] [z] - teleports"))
				register_concmd("amx_userorigin", "cmdUserOrigin", FLAG_AMX_USERORIGIN, _T("<name|#userid|authid> - displays position"))
			}
		}

		if(!is_plugin_running("jedi_force_grab.amx")) {
			register_clcmd("grab_toggle","grab_toggle",FLAG_GRAB,_T("- press once to grab and again to release a player"))
			register_clcmd("+grab","grab",FLAG_GRAB,_T("- grabs a player you aiming (bind a key to ^"+grab^")"))
			register_clcmd("-grab","release",FLAG_GRAB,_T("- ungrabs the player you aim"))
			g_cvar_sv_grabforce = register_cvar("sv_grabforce","8")
			register_event("StatusValue","spec_event","be","1=2")
		}
	}
}
/************************************************************************************************************************/
public plugin_end() { //Called on plugin end
	if(gClimbMap) {
		set_cvar_num("mp_friendlyfire",Cvar[0])
		set_cvar_num("mp_autoteambalance",Cvar[1])
		set_cvar_num("mp_teamlimit",Cvar[2])
		set_cvar_num("mp_flashlight",Cvar[3])

		//Check if nightmode is on...
		if (get_cvarptr_num(g_cvar_kz_nightmode) > 0) {
			//Yep, it's on...
			set_lights("a")
		}
		else{
			//Nope, it's off...
			set_lights("#OFF")
		}
	}
}
/*************************************************************************************************************************/
/**************************************************** HOOKED EVENTS ******************************************************/
/*************************************************************************************************************************/
public drop_weapons(id) {
	set_task(0.1, "remove_usp_scout", id+50)
}

public DeathMsg() 
{ 
	new id = read_data(2)
	gAlive[id] = false

	// User died, do they need to respawn???
	if(get_cvarptr_num(g_cvar_kz_autospawn) <= 0) {
		// No Need, remove his timer
		if (gHasTimer[id]) gHasTimer[id]=false
		return
	}

	// Yep, needs to respawn. Postpone with set_task for 0.5...	
	NVGcmd(id,0)
	entity_set_int(id, EV_INT_deadflag, DEAD_RESPAWNABLE)
	set_task(0.5,"respawn",id+123)

	#if defined USP_SCOUT_KILL {
	set_task(0.1, "remove_usp_scout", id+50)
	#endif

	// Jedi Force Grab
	if(grabmodeon & (1<<(id&31)))
	{
		release(id, FLAG_GRAB)
	}
}
/*************************************************************************************************************************/
/************************************************** USP/SCOUT REMOVE *****************************************************/
/*************************************************************************************************************************/
#if defined USP_SCOUT_KILL
find_ent_by_owner_small(index, const class[], owner) {
	if(index >= 0) index = -1
	while((index = find_entity(index, class)) > 0) {
		if(entity_get_edict(index, EV_ENT_owner) == owner) {
			return index
		}
	}
	return 0
}

public remove_usp_scout(id) {
	id -= 50
	if(gConnected[id]) {
		new ent = find_ent_by_owner_small(-1, "weaponbox", id)
		if(ent > 0) {
			new model[32]
			entity_get_string(ent, EV_SZ_model, model, charsmax(model))
			if(contain(model, "scout") != -1 || contain(model, "usp") != -1) {
				remove_entity(ent)
			}
		}
	}
}
#endif
/************************************************************************************************************************/
public respawn(id) 
{ 
	id -= 123
	if(gAlive[id] || get_user_team(id) != 2) return
	//Show a message to user that he is respawning
	client_print(id,print_chat, _T("[KZ] Respawning!"))
	//Respawn user...
	user_spawn(id)
}
/************************************************************************************************************************/
public ResetHUD(id) {
	set_offset_int(id, 192, 0) // Radio block.
	gAlive[id] = true

	//Check if Checkpoints are on...
	new kz_checkpoints
	if ((kz_checkpoints = get_cvarptr_num(g_cvar_kz_checkpoints)) > 0) {
		//Check if user has a Checkpoint
		if (gCheckpoint[id]) {
			//Yep he has one... Move him to it...
			if (CheckCheckpoint(id)) move_to_check(id)
			cs_set_user_money(id,0)
			//Check if limited Checkpointuse is on
			if (get_cvarptr_num(g_cvar_kz_limitedcp) > 0) {
				//Yep.. It is on... Delete Checkpoint
				gCheckpoint[id]=false
				client_print(id,print_chat,_T("[KZ] Checkpoint used..."))
			}
		}
		else {
			if (gHasTimer[id]) ResetTimer(id,1)
		}
	}
	else {
		if (gHasTimer[id]) ResetTimer(id,1)
	}

	//Chech if he just joined
	if (gJoined[id]) {
		get_user_origin(id,gLastCheckpointPos[id])
		gJoined[id] = false
		if (kz_checkpoints > 0) {
			client_print(id,print_chat,_T("[KZ] The plugin ^"KZ Multiplugin^" is enabled."))
			client_print(id,print_chat,_T("[KZ] Use checkpoints by typing ^"checkpoint^" & ^"gocheck^" in the console."))
			client_print(id,print_chat,_T("[KZ] If you get stuck type ^"/stuck^" in the chat to jump back to last checkpoint."))
		}
		else {
			client_print(id,print_chat,_T("* ^"KZ Multiplugin^" is disabled."))
		}
	}

	//Check if he gets godmode
	if (get_cvarptr_num(g_cvar_kz_godmode) > 0) {
		//Yep, it's on... Give it too him...
		set_user_godmode(id,1)
	}

	//Check if auto scout give is on...
	if (get_cvarptr_num(g_cvar_kz_scout) > 0) {
		//Yep, it's on... Give it too him...
		GiveScout(id)
	}

	//Check if he gets semiclip...
	if (get_cvarptr_num(g_cvar_kz_semiclip) > 0) {
		//Yep, it's on... Give it too him...
		entity_set_int(id, EV_INT_solid, SOLID_TRIGGER)
	}
	else{
		//Nope, it's off... Make sure he has clip
		entity_set_int(id, EV_INT_solid, SOLID_BBOX)
	}

	//Check if he is hooked to something
	if (gIsHooked[id]) RopeRelease(id)

	cs_set_user_money(id,gMoney[id])
}
/************************************************************************************************************************/
public Damage() {
	if(get_cvarptr_num(g_cvar_kz_autoheal) > 0) {
		new victim = read_data(0)
		set_user_health(victim, 100)
	}
} 
/************************************************************************************************************************/
public RestartRound() {
	//Check if nightmode is on...
	if (get_cvarptr_num(g_cvar_kz_nightmode) > 0) {
		//Yep, it's on...
		set_lights("a")
	}
	else{
		//Nope, it's off...
		set_lights("#OFF")
	}

	for (new id=1; id<=gMaxPlayers; id++) {
		if (gConnected[id]) {
			gCheckpoint[id]=false
			if (gHasTimer[id]) client_print(id,print_chat,_T("[KZ] Timer reset..."))
			ResetTimer(id,0)
		}
	}
}
/************************************************************************************************************************/
public Checkpoint(id, level) {
	if (!access(id, level)) {
		console_print(id, _T("You have no access to that command."))
		return PLUGIN_HANDLED
	}

	if (get_cvarptr_num(g_cvar_kz_checkpoints) <= 0) {
		client_print(id,print_console,_T("[KZ] Sorry, this command is disabled."))
		client_print(id,print_chat,_T("[KZ] Sorry, this command is disabled."))
		return PLUGIN_CONTINUE
	}

	new user_money = cs_get_user_money(id)
	new cvar_kz_checkprice = get_cvarptr_num(g_cvar_kz_checkprice)

	if (user_money < cvar_kz_checkprice) {
		client_print(id,print_console,_T("[KZ] Sorry, you need %i$ to buy a checkpoint."),cvar_kz_checkprice)
		client_print(id,print_chat,_T("[KZ] Sorry, you need %i$ to buy a checkpoint."),cvar_kz_checkprice)
		return PLUGIN_CONTINUE
	}

	if (get_user_button(id)&IN_DUCK) {
		client_print(id,print_console,_T("[KZ] You cannot place a checkpoint while ducking."))
		client_print(id,print_chat,_T("[KZ] You cannot place a checkpoint while ducking."))
		return PLUGIN_CONTINUE	
	}

	client_print(id,print_console,_T("[KZ] Saving position..."))
	client_print(id,print_chat,_T("[KZ] Saving position..."))

	cs_set_user_money(id, user_money - cvar_kz_checkprice)
	gMoney[id] = cs_get_user_money(id)

	if (gCheckpoint[id]) {
		gLastCheckpointPos[id][0] = gCheckpointPos[id][0]
		gLastCheckpointPos[id][1] = gCheckpointPos[id][1]
		gLastCheckpointPos[id][2] = gCheckpointPos[id][2]
	}

	get_user_origin(id,gCheckpointPos[id])
	gCheckpointPos[id][2] += 5
	gCheckpoint[id] = true
	gChecks[id] += 1

	return PLUGIN_HANDLED
}

public GoCheckpoint(id, level) {
	if (!access(id, level)) {
		console_print(id, _T("You have no access to that command."))
		return PLUGIN_HANDLED
	}

	if (get_cvarptr_num(g_cvar_kz_checkpoints) <= 0) {
		client_print(id,print_console,_T("[KZ] Sorry, this command is disabled."))
		client_print(id,print_chat,_T("[KZ] Sorry, this command is disabled."))
		return PLUGIN_CONTINUE
	}

	if (!gCheckpoint[id]) {
		client_print(id,print_console,_T("[KZ] You don't have a checkpoint."))
		client_print(id,print_chat,_T("[KZ] You don't have a checkpoint."))
		return PLUGIN_CONTINUE
	}

	if (CheckCheckpoint(id)) move_to_check(id)

	return PLUGIN_HANDLED
}

public LastCheckpoint(id, level) {
	if (!access(id, level)) {
		console_print(id, _T("You have no access to that command."))
		return PLUGIN_HANDLED
	}

	if (get_cvarptr_num(g_cvar_kz_checkpoints) <= 0) {
		client_print(id,print_console,_T("[KZ] Sorry, this command is disabled."))
		client_print(id,print_chat,_T("[KZ] Sorry, this command is disabled."))
		return PLUGIN_CONTINUE
	}

	if (!gCheckpoint[id]) {
		client_print(id,print_console,_T("[KZ] You don't have a checkpoint to revert to."))
		client_print(id,print_chat,_T("[KZ] You don't have a checkpoint to revert to."))
		return PLUGIN_CONTINUE
	}

	client_print(id,print_console,_T("[KZ] Reverting to last checkpoint."))
	client_print(id,print_chat,_T("[KZ] Reverting to last checkpoint."))

	gCheckpointPos[id][0] = gLastCheckpointPos[id][0]
	gCheckpointPos[id][1] = gLastCheckpointPos[id][1]
	gCheckpointPos[id][2] = gLastCheckpointPos[id][2]
	gCheckpoint[id] = true

	if (CheckCheckpoint(id)) move_to_check(id)

	return PLUGIN_HANDLED
}

CheckCheckpoint(id) {
	// Check if they can respawn
	new origin[33][3]
	new dist
	new cvar_kz_checkpointdist = get_cvarptr_num(g_cvar_kz_checkpointdist)
	for(new a = 1; a <= gMaxPlayers; a++) {
		if (a != id && gAlive[a]) {
			get_user_origin(a,origin[a])
			dist = get_distance(origin[a],gCheckpointPos[id])
			if (dist<=cvar_kz_checkpointdist) {
				client_print(id,print_console,_T("[KZ] You will respawn too close to another person. Please try later..."))
				client_print(id,print_chat,_T("[KZ] You will respawn too close to another person. Please try later..."))
				return false			
			}
		}
	}
	return true
}

public blocked(id) {
	return PLUGIN_HANDLED
}

/*************************************************************************************************************************/
/**************************************************** STOCK COMMANDS *****************************************************/
/*************************************************************************************************************************/
ClimbMap()
{
	if(file_exists(gConfigFile)) { 
		new gMapNameLen = get_mapname(gMapName, charsmax(gMapName))
		new line, stxtsize 
		new data[128]
		new MapName[32],aHeal[2],aSpawn[2],aBunny[2],aGodmode[2],aScout[2],aSemiClip[2],aNVG[2],nMode[2],cTimer[2],cTopS[2],cPoints[2],cPrice[6],cDist[6],cEffects[2],cLimited[2]
		while((line=read_file(gConfigFile,line,data,charsmax(data),stxtsize))!=0)
		{
			if ( stxtsize < (gMapNameLen + 2) || data[0] == ';' || data[0] == '#' || data[0] == '/' && data[1] == '/' ) continue
			parse(data,MapName,charsmax(MapName),aHeal,charsmax(aHeal),aSpawn,charsmax(aSpawn),aBunny,charsmax(aBunny),aGodmode,
			charsmax(aGodmode),aScout,charsmax(aScout),aSemiClip,charsmax(aSemiClip),aNVG,charsmax(aNVG),nMode,charsmax(nMode),
			cTimer,charsmax(cTimer),cTopS,charsmax(cTopS),cPoints,charsmax(cPoints),cPrice,charsmax(cPrice),cDist,charsmax(cDist),
			cEffects,charsmax(cEffects),cLimited,charsmax(cLimited))
			if (equali(MapName,gMapName)) {
				set_cvarptr_string(g_cvar_kz_autoheal,aHeal)
				set_cvarptr_string(g_cvar_kz_autospawn,aSpawn)
				set_cvarptr_string(g_cvar_kz_bunnyjump,aBunny)
				set_cvarptr_string(g_cvar_kz_godmode,aGodmode)
				set_cvarptr_string(g_cvar_kz_scout,aScout)
				set_cvarptr_string(g_cvar_kz_semiclip,aSemiClip)
				set_cvarptr_string(g_cvar_kz_nightvision,aNVG)
				set_cvarptr_string(g_cvar_kz_nightmode,nMode)
				set_cvarptr_string(g_cvar_kz_timer,cTimer)
				set_cvarptr_string(g_cvar_kz_top15,cTopS)
				set_cvarptr_string(g_cvar_kz_checkpoints,cPoints)
				set_cvarptr_string(g_cvar_kz_checkprice,cPrice)
				set_cvarptr_string(g_cvar_kz_checkpointdist,cDist)
				set_cvarptr_string(g_cvar_kz_checkeffects,cEffects)
				set_cvarptr_string(g_cvar_kz_limitedcp,cLimited)
				return true
			}
		}
		return false
	}
	else {
		log_amx(_T("[KZ] Error: Failed to load the KZ config file (%s)."), gConfigFile)
		return false
	}
	return false
}

kz_velocity_get(id,vel[3]) {
	//Set Their Velocity to 0 so that they they fall straight down from
	new Float:Ivel[3]
	entity_get_vector(id, EV_VEC_velocity, Ivel)
	vel[0]=floatround(Ivel[0])
	vel[1]=floatround(Ivel[1])
	vel[2]=floatround(Ivel[2])
}

kz_velocity_set(id,const vel[3]) {
	//Set Their Velocity to 0 so that they they fall straight down from
	new Float:Ivel[3]
	Ivel[0]=float(vel[0])
	Ivel[1]=float(vel[1])
	Ivel[2]=float(vel[2])
	entity_set_vector(id, EV_VEC_velocity, Ivel)
}

move_to_check(id) {
	new vel[3]
	kz_velocity_set(id,vel)
	//Check if Effects are enabled
	if (get_cvarptr_num(g_cvar_kz_checkeffects)>0) {
		//Yep They Are
		new CurOrig[3]
		get_user_origin(id,CurOrig)
		message_begin(MSG_BROADCAST,SVC_TEMPENTITY) 
		write_byte(11) 
		write_coord(CurOrig[0]) 
		write_coord(CurOrig[1]) 
		write_coord(CurOrig[2]) 
		message_end() 
		message_begin(MSG_BROADCAST,SVC_TEMPENTITY) 
		write_byte(11) 
		write_coord(gCheckpointPos[id][0]) 
		write_coord(gCheckpointPos[id][1]) 
		write_coord(gCheckpointPos[id][2]) 
		message_end() 
	}
	//Move To Checkpoint
	set_user_origin(id,gCheckpointPos[id])
}

FormatTime(iMins,iSecs,iHuns,sMins[],sSecs[],sHuns[]) {
	if (iHuns==0) {
		copy(sHuns,2,"00")
	} else {
		formatex(sHuns,2,"%d",iHuns)
	}
	if (iSecs<10) {
		formatex(sSecs,2,"0%d",iSecs)
	} else {
		formatex(sSecs,2,"%d",iSecs)
	}
	if (iMins<10) {
		formatex(sMins,2,"0%d",iMins)
	} else {
		formatex(sMins,2,"%d",iMins)
	}
	return 1
}

GiveScout(id) {
	if(!has_user_weapon(id, CSW_SCOUT)) {
		give_item(id, "weapon_scout")
		#if !defined NO_STEAM
		set_offset_int(id, 378, 90)
		#else
		set_offset_int(id, 382, 90)
		#endif
	}
}

CheatDetect(id,const cheat[]) {
	if (gHasTimer[id]) {
		client_print(id,print_chat,_T("[KZ] %s detected... Timer terminated."),_T(cheat))
		ResetTimer(id,0)
	}
}
/************************************************************************************************************************/
/**************************************************** ADMIN COMMANDS ****************************************************/
/************************************************************************************************************************/

// Admin Semiclip
public cmdSemiClip(id, iLevel, iCommandId) {
  if(!cmd_access(id, iLevel, iCommandId, 3))
    return PLUGIN_HANDLED

  new szTarget[32], szStatus[2], iPlayer
  read_argv(1, szTarget, charsmax(szTarget))
  read_argv(2, szStatus, charsmax(szStatus))
  new iSemiClipStatus = (str_to_num(szStatus) > 0) ? 1 : 0
  new bool:bHasSupreme = bool:(get_user_flags(id) & ADMIN_SUPREME)
  new szAdminName[32], szPlayerName[32]
  if(id == 0) szAdminName = "SERVER"
  else get_user_name(id, szAdminName, charsmax(szAdminName))

  #if defined USE_LOGS
  new szAdminAuthid[24], szAdminIpAddress[24]
  get_user_authid(id, szAdminAuthid, charsmax(szAdminAuthid))
  get_user_ip(id, szAdminIpAddress, charsmax(szAdminIpAddress), 1)
  #endif

  if(szTarget[0] == '*') {
    new iPlayers[32], iPlayersNum, iBlockedPlayersNum
    get_players(iPlayers, iPlayersNum, "ah")
    if(iPlayersNum > 0) {
      for(new i = 0; i < iPlayersNum; i++) {
        iPlayer = iPlayers[i]
        if((iPlayer != id) && (bHasSupreme == false) && (get_user_flags(iPlayer) & ADMIN_IMMUNITY)) {
          get_user_name(iPlayer, szPlayerName, charsmax(szPlayerName))
          console_print(id, _T("Player ^"%s^" has immunity."), szPlayerName)
          iBlockedPlayersNum++
          continue
        }
        entity_set_int(iPlayer, EV_INT_solid, iSemiClipStatus ? SOLID_TRIGGER : SOLID_BBOX)
      }

      if(iBlockedPlayersNum == iPlayersNum) {
        console_print(id, _T("That action can't be performed on selected players."))
        return PLUGIN_HANDLED
      }

      #if defined USE_LOGS
      if(iSemiClipStatus) log_amx("KZ Multiplugin: ^"%s<%d><%s><%s>^" give semiclip to all players",
      szAdminName, get_user_userid(id), szAdminAuthid, szAdminIpAddress)
      else log_amx("KZ Multiplugin: ^"%s<%d><%s><%s>^" remove semiclip from all players",
      szAdminName, get_user_userid(id), szAdminAuthid, szAdminIpAddress)
      #endif

      #if !defined COLORED_ACTIVITY
      if(iSemiClipStatus) show_activity(id, szAdminName, _T("give semiclip to all players."))
      else show_activity(id, szAdminName, _T("remove semiclip from all players."))
      #else
      if(iSemiClipStatus) show_activity_color(id, szAdminName, _T("give semiclip to all players."))
      else show_activity_color(id, szAdminName, _T("remove semiclip from all players."))
      #endif
      if(iSemiClipStatus) console_print(id, _T("Semiclip given to all players."))
      else console_print(id, _T("Semiclip removed from all players."))
    }
    else {
      console_print(id, _T("No alive player on the server."))
    }
  }
  else if(szTarget[0] == '@') {
    new iPlayers[32], iPlayersNum, iBlockedPlayersNum
    get_players(iPlayers, iPlayersNum, "aegh", szTarget[1])
    if(iPlayersNum > 0) {
      for(new i = 0; i < iPlayersNum; i++) {
        iPlayer = iPlayers[i]
        if((iPlayer != id) && (bHasSupreme == false) && (get_user_flags(iPlayer) & ADMIN_IMMUNITY)) {
          get_user_name(iPlayer, szPlayerName, charsmax(szPlayerName))
          console_print(id, _T("Player ^"%s^" has immunity."), szPlayerName)
          iBlockedPlayersNum++
          continue
        }
        entity_set_int(iPlayer, EV_INT_solid, iSemiClipStatus ? SOLID_TRIGGER : SOLID_BBOX)
      }

      if(iBlockedPlayersNum == iPlayersNum) {
        console_print(id, _T("That action can't be performed on selected players."))
        return PLUGIN_HANDLED
      }

      new szTeamName[12]
      switch(szTarget[1]) {
        case '1', 't', 'T': copy(szTeamName, charsmax(szTeamName), "TERRORISTS")
        case '2', 'c', 'C': copy(szTeamName, charsmax(szTeamName), "CTs")
      }

      #if defined USE_LOGS
      if(iSemiClipStatus) log_amx("KZ Multiplugin: ^"%s<%d><%s><%s>^" give semiclip to the %s",
      szAdminName, get_user_userid(id), szAdminAuthid, szAdminIpAddress, szTeamName)
      else log_amx("KZ Multiplugin: ^"%s<%d><%s><%s>^" remove semiclip from the %s",
      szAdminName, get_user_userid(id), szAdminAuthid, szAdminIpAddress, szTeamName)
      #endif

      #if !defined COLORED_ACTIVITY
      if(iSemiClipStatus) show_activity(id, szAdminName, _T("give semiclip to the %s."), _T(szTeamName))
      else show_activity(id, szAdminName, _T("remove semiclip from the %s."), _T(szTeamName))
      #else
      if(iSemiClipStatus) show_activity_color(id, szAdminName, _T("give semiclip to the %s."), _T(szTeamName))
      else show_activity_color(id, szAdminName, _T("remove semiclip from the %s."), _T(szTeamName))
      #endif
      if(iSemiClipStatus) console_print(id, _T("Semiclip given to the %s."), _T(szTeamName))
      else console_print(id, _T("Semiclip removed from the %s."), _T(szTeamName))
    }
    else {
      console_print(id, _T("No alive player in this team."))
    }
  }
  else {
    iPlayer = cmd_target(id, szTarget, 7)
    if(!iPlayer)
      return PLUGIN_HANDLED

    entity_set_int(iPlayer, EV_INT_solid, iSemiClipStatus ? SOLID_TRIGGER : SOLID_BBOX)
    get_user_name(iPlayer, szPlayerName, charsmax(szPlayerName))

    #if defined USE_LOGS
    new szPlayerAuthid[24], szPlayerIpAddress[24]
    get_user_authid(iPlayer, szPlayerAuthid, charsmax(szPlayerAuthid))
    get_user_ip(iPlayer, szPlayerIpAddress, charsmax(szPlayerIpAddress), 1)
    if(iSemiClipStatus) log_amx("KZ Multiplugin: ^"%s<%d><%s><%s>^" give semiclip to ^"%s<%d><%s><%s>^"",
    szAdminName, get_user_userid(id), szAdminAuthid, szAdminIpAddress,
    szPlayerName, get_user_userid(iPlayer), szPlayerAuthid, szPlayerIpAddress)
    else log_amx("KZ Multiplugin: ^"%s<%d><%s><%s>^" remove semiclip from ^"%s<%d><%s><%s>^"",
    szAdminName, get_user_userid(id), szAdminAuthid, szAdminIpAddress,
    szPlayerName, get_user_userid(iPlayer), szPlayerAuthid, szPlayerIpAddress)
    #endif

    #if !defined COLORED_ACTIVITY
    if(iSemiClipStatus) show_activity(id, szAdminName, _T("give semiclip to %s."), szPlayerName)
    else show_activity(id, szAdminName, _T("remove semiclip from %s."), szPlayerName)
    #else
    if(iSemiClipStatus) show_activity_color(id, szAdminName, _T("give semiclip to %s."), szPlayerName)
    else show_activity_color(id, szAdminName, _T("remove semiclip from %s."), szPlayerName)
    #endif
    if(iSemiClipStatus) console_print(id, _T("Semiclip given to %s."), szPlayerName)
    else console_print(id, _T("Semiclip removed from %s."), szPlayerName)
  }
  return PLUGIN_HANDLED
}

// Admin GrantHook
public cmdGrantHook(id, iLevel, iCommandId) {
  if(!cmd_access(id, iLevel, iCommandId, 3))
    return PLUGIN_HANDLED

  new szTarget[32], szStatus[2], iPlayer
  read_argv(1, szTarget, charsmax(szTarget))
  read_argv(2, szStatus, charsmax(szStatus))
  new iHookStatus = (str_to_num(szStatus) > 0) ? 1 : 0
  new bool:bHasSupreme = bool:(get_user_flags(id) & ADMIN_SUPREME)
  new szAdminName[32], szPlayerName[32]
  if(id == 0) szAdminName = "SERVER"
  else get_user_name(id, szAdminName, charsmax(szAdminName))

  #if defined USE_LOGS
  new szAdminAuthid[24], szAdminIpAddress[24]
  get_user_authid(id, szAdminAuthid, charsmax(szAdminAuthid))
  get_user_ip(id, szAdminIpAddress, charsmax(szAdminIpAddress), 1)
  #endif

  if(szTarget[0] == '*') {
    new iPlayers[32], iPlayersNum, iBlockedPlayersNum
    get_players(iPlayers, iPlayersNum, "ch")
    if(iPlayersNum > 0) {
      for(new i = 0; i < iPlayersNum; i++) {
        iPlayer = iPlayers[i]
        if((iPlayer != id) && (bHasSupreme == false) && (get_user_flags(iPlayer) & ADMIN_IMMUNITY)) {
          get_user_name(iPlayer, szPlayerName, charsmax(szPlayerName))
          console_print(id, _T("Player ^"%s^" has immunity."), szPlayerName)
          iBlockedPlayersNum++
          continue
        }
        gAllowedHook[iPlayer] = iHookStatus
        if(!iHookStatus && gIsHooked[iPlayer] == true) {
          RopeRelease(iPlayer)
        }
      }

      if(iBlockedPlayersNum == iPlayersNum) {
        console_print(id, _T("That action can't be performed on selected players."))
        return PLUGIN_HANDLED
      }

      #if defined USE_LOGS
      if(iHookStatus) log_amx("KZ Multiplugin: ^"%s<%d><%s><%s>^" give granthook powers to all players",
      szAdminName, get_user_userid(id), szAdminAuthid, szAdminIpAddress)
      else log_amx("KZ Multiplugin: ^"%s<%d><%s><%s>^" remove granthook powers from all players",
      szAdminName, get_user_userid(id), szAdminAuthid, szAdminIpAddress)
      #endif

      #if !defined COLORED_ACTIVITY
      if(iHookStatus) show_activity(id, szAdminName, _T("give granthook powers to all players."))
      else show_activity(id, szAdminName, _T("remove granthook powers from all players."))
      #else
      if(iHookStatus) show_activity_color(id, szAdminName, _T("give granthook powers to all players."))
      else show_activity_color(id, szAdminName, _T("remove granthook powers from all players."))
      #endif
      if(iHookStatus) console_print(id, _T("Granthook powers given to all players."))
      else console_print(id, _T("Granthook powers removed from all players."))
    }
    else {
      console_print(id, _T("No real player on the server."))
    }
  }
  else if(szTarget[0] == '@') {
    new iPlayers[32], iPlayersNum, iBlockedPlayersNum
    get_players(iPlayers, iPlayersNum, "cegh", szTarget[1])
    if(iPlayersNum > 0) {
      for(new i = 0; i < iPlayersNum; i++) {
        iPlayer = iPlayers[i]
        if((iPlayer != id) && (bHasSupreme == false) && (get_user_flags(iPlayer) & ADMIN_IMMUNITY)) {
          get_user_name(iPlayer, szPlayerName, charsmax(szPlayerName))
          console_print(id, _T("Player ^"%s^" has immunity."), szPlayerName)
          iBlockedPlayersNum++
          continue
        }
        gAllowedHook[iPlayer] = iHookStatus
        if(!iHookStatus && gIsHooked[iPlayer] == true) {
          RopeRelease(iPlayer)
        }
      }

      if(iBlockedPlayersNum == iPlayersNum) {
        console_print(id, _T("That action can't be performed on selected players."))
        return PLUGIN_HANDLED
      }

      new szTeamName[12]
      switch(szTarget[1]) {
        case '1', 't', 'T': copy(szTeamName, charsmax(szTeamName), "TERRORISTS")
        case '2', 'c', 'C': copy(szTeamName, charsmax(szTeamName), "CTs")
      }

      #if defined USE_LOGS
      if(iHookStatus) log_amx("KZ Multiplugin: ^"%s<%d><%s><%s>^" give granthook powers to the %s",
      szAdminName, get_user_userid(id), szAdminAuthid, szAdminIpAddress, szTeamName)
      else log_amx("KZ Multiplugin: ^"%s<%d><%s><%s>^" remove granthook powers from the %s",
      szAdminName, get_user_userid(id), szAdminAuthid, szAdminIpAddress, szTeamName)
      #endif

      #if !defined COLORED_ACTIVITY
      if(iHookStatus) show_activity(id, szAdminName, _T("give granthook powers to the %s."), _T(szTeamName))
      else show_activity(id, szAdminName, _T("remove granthook powers from the %s."), _T(szTeamName))
      #else
      if(iHookStatus) show_activity_color(id, szAdminName, _T("give granthook powers to the %s."), _T(szTeamName))
      else show_activity_color(id, szAdminName, _T("remove granthook powers from the %s."), _T(szTeamName))
      #endif
      if(iHookStatus) console_print(id, _T("Granthook powers given to the %s."), _T(szTeamName))
      else console_print(id, _T("Granthook powers removed from the %s."), _T(szTeamName))
    }
    else {
      console_print(id, _T("No real player in this team."))
    }
  }
  else {
    iPlayer = cmd_target(id, szTarget, 11)
    if(!iPlayer)
      return PLUGIN_HANDLED

    gAllowedHook[iPlayer] = iHookStatus
    if(!iHookStatus && gIsHooked[iPlayer] == true) {
      RopeRelease(iPlayer)
    }

    get_user_name(iPlayer, szPlayerName, charsmax(szPlayerName))

    #if defined USE_LOGS
    new szPlayerAuthid[24], szPlayerIpAddress[24]
    get_user_authid(iPlayer, szPlayerAuthid, charsmax(szPlayerAuthid))
    get_user_ip(iPlayer, szPlayerIpAddress, charsmax(szPlayerIpAddress), 1)
    if(iHookStatus) log_amx("KZ Multiplugin: ^"%s<%d><%s><%s>^" give granthook powers to ^"%s<%d><%s><%s>^"",
    szAdminName, get_user_userid(id), szAdminAuthid, szAdminIpAddress,
    szPlayerName, get_user_userid(iPlayer), szPlayerAuthid, szPlayerIpAddress)
    else log_amx("KZ Multiplugin: ^"%s<%d><%s><%s>^" remove granthook powers from ^"%s<%d><%s><%s>^"",
    szAdminName, get_user_userid(id), szAdminAuthid, szAdminIpAddress,
    szPlayerName, get_user_userid(iPlayer), szPlayerAuthid, szPlayerIpAddress)
    #endif

    #if !defined COLORED_ACTIVITY
    if(iHookStatus) show_activity(id, szAdminName, _T("give granthook powers to %s."), szPlayerName)
    else show_activity(id, szAdminName, _T("remove granthook powers from %s."), szPlayerName)
    #else
    if(iHookStatus) show_activity_color(id, szAdminName, _T("give granthook powers to %s."), szPlayerName)
    else show_activity_color(id, szAdminName, _T("remove granthook powers from %s."), szPlayerName)
    #endif
    if(iHookStatus) console_print(id, _T("Granthook powers given to %s."), szPlayerName)
    else console_print(id, _T("Granthook powers removed from %s."), szPlayerName)
  }
  return PLUGIN_HANDLED
}

// Admin LongJump
public cmdLongJump(id, iLevel, iCommandId) {
  if(!cmd_access(id, iLevel, iCommandId, 2))
    return PLUGIN_HANDLED

  new szTarget[32], iPlayer
  read_argv(1, szTarget, charsmax(szTarget))
  new bool:bHasSupreme = bool:(get_user_flags(id) & ADMIN_SUPREME)
  new szAdminName[32], szPlayerName[32]
  if(id == 0) szAdminName = "SERVER"
  else get_user_name(id, szAdminName, charsmax(szAdminName))

  #if defined USE_LOGS
  new szAdminAuthid[24], szAdminIpAddress[24]
  get_user_authid(id, szAdminAuthid, charsmax(szAdminAuthid))
  get_user_ip(id, szAdminIpAddress, charsmax(szAdminIpAddress), 1)
  #endif

  if(szTarget[0] == '*') {
    new iPlayers[32], iPlayersNum, iBlockedPlayersNum
    get_players(iPlayers, iPlayersNum, "ah")
    if(iPlayersNum > 0) {
      for(new i = 0; i < iPlayersNum; i++) {
        iPlayer = iPlayers[i]
        if((iPlayer != id) && (bHasSupreme == false) && (get_user_flags(iPlayer) & ADMIN_IMMUNITY)) {
          get_user_name(iPlayer, szPlayerName, charsmax(szPlayerName))
          console_print(id, _T("Player ^"%s^" has immunity."), szPlayerName)
          iBlockedPlayersNum++
          continue
        }
        give_item(iPlayer, "item_longjump")
        emit_sound(iPlayer, CHAN_ITEM, "fvox/powermove_on.wav", VOL_NORM, ATTN_NORM, 0, PITCH_NORM)
        CheatDetect(iPlayer, "LongJump")
      }

      if(iBlockedPlayersNum == iPlayersNum) {
        console_print(id, _T("That action can't be performed on selected players."))
        return PLUGIN_HANDLED
      }

      #if defined USE_LOGS
      log_amx("KZ Multiplugin: ^"%s<%d><%s><%s>^" give a LongJump to all players",
      szAdminName, get_user_userid(id), szAdminAuthid, szAdminIpAddress)
      #endif

      #if !defined COLORED_ACTIVITY
      show_activity(id, szAdminName, _T("give a LongJump to all players."))
      #else
      show_activity_color(id, szAdminName, _T("give a LongJump to all players."))
      #endif
      console_print(id, _T("LongJump given to all players."))
    }
    else {
      console_print(id, _T("No alive player on the server."))
    }
  }
  else if(szTarget[0] == '@') {
    new iPlayers[32], iPlayersNum, iBlockedPlayersNum
    get_players(iPlayers, iPlayersNum, "aegh", szTarget[1])
    if(iPlayersNum > 0) {
      for(new i = 0; i < iPlayersNum; i++) {
        iPlayer = iPlayers[i]
        if((iPlayer != id) && (bHasSupreme == false) && (get_user_flags(iPlayer) & ADMIN_IMMUNITY)) {
          get_user_name(iPlayer, szPlayerName, charsmax(szPlayerName))
          console_print(id, _T("Player ^"%s^" has immunity."), szPlayerName)
          iBlockedPlayersNum++
          continue
        }
        give_item(iPlayer, "item_longjump")
        emit_sound(iPlayer, CHAN_ITEM, "fvox/powermove_on.wav", VOL_NORM, ATTN_NORM, 0, PITCH_NORM)
        CheatDetect(iPlayer, "LongJump")
      }

      if(iBlockedPlayersNum == iPlayersNum) {
        console_print(id, _T("That action can't be performed on selected players."))
        return PLUGIN_HANDLED
      }

      new szTeamName[12]
      switch(szTarget[1]) {
        case '1', 't', 'T': copy(szTeamName, charsmax(szTeamName), "TERRORISTS")
        case '2', 'c', 'C': copy(szTeamName, charsmax(szTeamName), "CTs")
      }

      #if defined USE_LOGS
      log_amx("KZ Multiplugin: ^"%s<%d><%s><%s>^" give a LongJump to the %s",
      szAdminName, get_user_userid(id), szAdminAuthid, szAdminIpAddress, szTeamName)
      #endif

      #if !defined COLORED_ACTIVITY
      show_activity(id, szAdminName, _T("give a LongJump to the %s."), _T(szTeamName))
      #else
      show_activity_color(id, szAdminName, _T("give a LongJump to the %s."), _T(szTeamName))
      #endif
      console_print(id, _T("LongJump given to the %s."), _T(szTeamName))
    }
    else {
      console_print(id, _T("No alive player in this team."))
    }
  }
  else {
    iPlayer = cmd_target(id, szTarget, 7)
    if(!iPlayer)
      return PLUGIN_HANDLED

    give_item(iPlayer, "item_longjump")
    emit_sound(iPlayer, CHAN_ITEM, "fvox/powermove_on.wav", VOL_NORM, ATTN_NORM, 0, PITCH_NORM)
    CheatDetect(iPlayer, "LongJump")

    get_user_name(iPlayer, szPlayerName, charsmax(szPlayerName))

    #if defined USE_LOGS
    new szPlayerAuthid[24], szPlayerIpAddress[24]
    get_user_authid(iPlayer, szPlayerAuthid, charsmax(szPlayerAuthid))
    get_user_ip(iPlayer, szPlayerIpAddress, charsmax(szPlayerIpAddress), 1)
    log_amx("KZ Multiplugin: ^"%s<%d><%s><%s>^" give a LongJump to ^"%s<%d><%s><%s>^"",
    szAdminName, get_user_userid(id), szAdminAuthid, szAdminIpAddress,
    szPlayerName, get_user_userid(iPlayer), szPlayerAuthid, szPlayerIpAddress)
    #endif

    #if !defined COLORED_ACTIVITY
    show_activity(id, szAdminName, _T("give a LongJump to %s."), szPlayerName)
    #else
    show_activity_color(id, szAdminName, _T("give a LongJump to %s."), szPlayerName)
    #endif
    console_print(id, _T("LongJump given to %s."), szPlayerName)
  }
  return PLUGIN_HANDLED
}

// Admin Scout
public cmdScout(id, iLevel, iCommandId) {
  if(!cmd_access(id, iLevel, iCommandId, 2))
    return PLUGIN_HANDLED

  new szTarget[32], iPlayer
  read_argv(1, szTarget, charsmax(szTarget))
  new bool:bHasSupreme = bool:(get_user_flags(id) & ADMIN_SUPREME)
  new szAdminName[32], szPlayerName[32]
  if(id == 0) szAdminName = "SERVER"
  else get_user_name(id, szAdminName, charsmax(szAdminName))

  #if defined USE_LOGS
  new szAdminAuthid[24], szAdminIpAddress[24]
  get_user_authid(id, szAdminAuthid, charsmax(szAdminAuthid))
  get_user_ip(id, szAdminIpAddress, charsmax(szAdminIpAddress), 1)
  #endif

  if(szTarget[0] == '*') {
    new iPlayers[32], iPlayersNum, iBlockedPlayersNum
    get_players(iPlayers, iPlayersNum, "ah")
    if(iPlayersNum > 0) {
      for(new i = 0; i < iPlayersNum; i++) {
        iPlayer = iPlayers[i]
        if((iPlayer != id) && (bHasSupreme == false) && (get_user_flags(iPlayer) & ADMIN_IMMUNITY)) {
          get_user_name(iPlayer, szPlayerName, charsmax(szPlayerName))
          console_print(id, _T("Player ^"%s^" has immunity."), szPlayerName)
          iBlockedPlayersNum++
          continue
        }
        GiveScout(iPlayer)
      }

      if(iBlockedPlayersNum == iPlayersNum) {
        console_print(id, _T("That action can't be performed on selected players."))
        return PLUGIN_HANDLED
      }

      #if defined USE_LOGS
      log_amx("KZ Multiplugin: ^"%s<%d><%s><%s>^" give a Steyr Scout to all players",
      szAdminName, get_user_userid(id), szAdminAuthid, szAdminIpAddress)
      #endif

      #if !defined COLORED_ACTIVITY
      show_activity(id, szAdminName, _T("give a Steyr Scout to all players."))
      #else
      show_activity_color(id, szAdminName, _T("give a Steyr Scout to all players."))
      #endif
      console_print(id, _T("Steyr Scout given to all players."))
    }
    else {
      console_print(id, _T("No alive player on the server."))
    }
  }
  else if(szTarget[0] == '@') {
    new iPlayers[32], iPlayersNum, iBlockedPlayersNum
    get_players(iPlayers, iPlayersNum, "aegh", szTarget[1])
    if(iPlayersNum > 0) {
      for(new i = 0; i < iPlayersNum; i++) {
        iPlayer = iPlayers[i]
        if((iPlayer != id) && (bHasSupreme == false) && (get_user_flags(iPlayer) & ADMIN_IMMUNITY)) {
          get_user_name(iPlayer, szPlayerName, charsmax(szPlayerName))
          console_print(id, _T("Player ^"%s^" has immunity."), szPlayerName)
          iBlockedPlayersNum++
          continue
        }
        GiveScout(iPlayer)
      }

      if(iBlockedPlayersNum == iPlayersNum) {
        console_print(id, _T("That action can't be performed on selected players."))
        return PLUGIN_HANDLED
      }

      new szTeamName[12]
      switch(szTarget[1]) {
        case '1', 't', 'T': copy(szTeamName, charsmax(szTeamName), "TERRORISTS")
        case '2', 'c', 'C': copy(szTeamName, charsmax(szTeamName), "CTs")
      }

      #if defined USE_LOGS
      log_amx("KZ Multiplugin: ^"%s<%d><%s><%s>^" give a Steyr Scout to the %s",
      szAdminName, get_user_userid(id), szAdminAuthid, szAdminIpAddress, szTeamName)
      #endif

      #if !defined COLORED_ACTIVITY
      show_activity(id, szAdminName, _T("give a Steyr Scout to the %s."), _T(szTeamName))
      #else
      show_activity_color(id, szAdminName, _T("give a Steyr Scout to the %s."), _T(szTeamName))
      #endif
      console_print(id, _T("Steyr Scout given to the %s."), _T(szTeamName))
    }
    else {
      console_print(id, _T("No alive player in this team."))
    }
  }
  else {
    iPlayer = cmd_target(id, szTarget, 7)
    if(!iPlayer)
      return PLUGIN_HANDLED

    GiveScout(iPlayer)

    get_user_name(iPlayer, szPlayerName, charsmax(szPlayerName))

    #if defined USE_LOGS
    new szPlayerAuthid[24], szPlayerIpAddress[24]
    get_user_authid(iPlayer, szPlayerAuthid, charsmax(szPlayerAuthid))
    get_user_ip(iPlayer, szPlayerIpAddress, charsmax(szPlayerIpAddress), 1)
    log_amx("KZ Multiplugin: ^"%s<%d><%s><%s>^" give a Steyr Scout to ^"%s<%d><%s><%s>^"",
    szAdminName, get_user_userid(id), szAdminAuthid, szAdminIpAddress,
    szPlayerName, get_user_userid(iPlayer), szPlayerAuthid, szPlayerIpAddress)
    #endif

    #if !defined COLORED_ACTIVITY
    show_activity(id, szAdminName, _T("give a Steyr Scout to %s."), szPlayerName)
    #else
    show_activity_color(id, szAdminName, _T("give a Steyr Scout to %s."), szPlayerName)
    #endif
    console_print(id, _T("Steyr Scout given to %s."), szPlayerName)
  }
  return PLUGIN_HANDLED
}

// Admin Set/Rem Checkpoint
public cmdSetCheck(id, iLevel, iCommandId) {
  if(!cmd_access(id, iLevel, iCommandId, 2))
    return PLUGIN_HANDLED

  new szTarget[32]
  read_argv(1, szTarget, charsmax(szTarget))
  new iPlayer = cmd_target(id, szTarget, 7)
  if(!iPlayer)
    return PLUGIN_HANDLED

  new iOrigin[3], bool:bFindZAxis
  if(id == 0) {
    new szOrigin[6]
    for(new i = 2; i <= 4; i++) {
      read_argv(i, szOrigin, charsmax(szOrigin))
      iOrigin[i - 2] = szOrigin[0] ? str_to_num(szOrigin) : iOrigin[i - 2]
      if(i == 4 && szOrigin[0]) bFindZAxis = true
    }

    if(bFindZAxis == false) {
      console_print(id, _T("[KZ] You have to specify an origin is you use the command from the server console."))
      console_print(id, _T("Usage: amx_checkpoint <name|#userid|authid> [x] [y] [z] - sets checkpoint"))
      return PLUGIN_HANDLED
    }
  }

  if(id > 0)
    get_user_origin(id, gCheckpointPos[iPlayer]) // from id's origin
  else {
    gCheckpointPos[iPlayer][0] = iOrigin[0]
    gCheckpointPos[iPlayer][1] = iOrigin[1]
    gCheckpointPos[iPlayer][2] = iOrigin[2]
  }

  gCheckpointPos[iPlayer][2] += 3
  gCheckpoint[iPlayer] = true
  gChecks[iPlayer]++
  CheatDetect(iPlayer, "Admin Checkpoint Change")

  new szAdminName[32], szPlayerName[32]
  if(id == 0) szAdminName = "SERVER"
  else get_user_name(id, szAdminName, charsmax(szAdminName))
  get_user_name(iPlayer, szPlayerName, charsmax(szPlayerName))

  #if defined USE_LOGS
  new szAdminAuthid[24], szAdminIpAddress[24], szPlayerAuthid[24], szPlayerIpAddress[24]
  get_user_authid(id, szAdminAuthid, charsmax(szAdminAuthid))
  get_user_ip(id, szAdminIpAddress, charsmax(szAdminIpAddress))
  get_user_authid(iPlayer, szPlayerAuthid, charsmax(szPlayerAuthid))
  get_user_ip(iPlayer, szPlayerIpAddress, charsmax(szPlayerIpAddress))
  log_amx("KZ Multiplugin: ^"%s<%d><%s><%s>^" set checkpoint for ^"%s<%d><%s><%s>^".",
  szAdminName, get_user_userid(id), szAdminAuthid, szAdminIpAddress,
  szPlayerName, get_user_userid(iPlayer), szPlayerAuthid, szPlayerIpAddress)
  #endif

  #if !defined COLORED_ACTIVITY
  show_activity(id, szAdminName, _T("set checkpoint for %s."), szPlayerName)
  #else
  show_activity_color(id, szAdminName, _T("set checkpoint for %s."), szPlayerName)
  #endif
  console_print(id, _T("Checkpoint set for player ^"%s^"."), szPlayerName)
  return PLUGIN_HANDLED
}

public cmdRemCheck(id, iLevel, iCommandId) {
  if(!cmd_access(id, iLevel, iCommandId, 2))
    return PLUGIN_HANDLED

  new szTarget[32]
  read_argv(1, szTarget, charsmax(szTarget))
  new iPlayer = cmd_target(id, szTarget, 7)
  if(!iPlayer)
    return PLUGIN_HANDLED

  gCheckpoint[iPlayer] = false
  gChecks[iPlayer] = 0

  new szAdminName[32], szPlayerName[32]
  if(id == 0) szAdminName = "SERVER"
  else get_user_name(id, szAdminName, charsmax(szAdminName))
  get_user_name(iPlayer, szPlayerName, charsmax(szPlayerName))

  #if defined USE_LOGS
  new szAdminAuthid[24], szAdminIpAddress[24], szPlayerAuthid[24], szPlayerIpAddress[24]
  get_user_authid(id, szAdminAuthid, charsmax(szAdminAuthid))
  get_user_ip(id, szAdminIpAddress, charsmax(szAdminIpAddress))
  get_user_authid(iPlayer, szPlayerAuthid, charsmax(szPlayerAuthid))
  get_user_ip(iPlayer, szPlayerIpAddress, charsmax(szPlayerIpAddress))
  log_amx("KZ Multiplugin: ^"%s<%d><%s><%s>^" remove checkpoint from ^"%s<%d><%s><%s>^".",
  szAdminName, get_user_userid(id), szAdminAuthid, szAdminIpAddress,
  szPlayerName, get_user_userid(iPlayer), szPlayerAuthid, szPlayerIpAddress)
  #endif

  #if !defined COLORED_ACTIVITY
  show_activity(id, szAdminName, _T("remove checkpoint from %s."), szPlayerName)
  #else
  show_activity_color(id, szAdminName, _T("remove checkpoint from %s."), szPlayerName)
  #endif
  console_print(id, _T("Checkpoint removed from player ^"%s^"."), szPlayerName)
  return PLUGIN_HANDLED
}

// Admin Glow
const MAX_COLORS = 10
new const g_szColorsNames[MAX_COLORS][] = {"white", "red", "green", "blue", "yellow", "magenta", "cyan", "orange", "amx", "amxmod"}
new const g_iColorsValues[MAX_COLORS][] = {
  {255, 255, 255}, // white
  {255, 0, 0}, // red
  {0, 255, 0}, // green
  {0, 0, 255}, // blue
  {255, 255, 0}, // yellow
  {255, 0, 255}, // magenta
  {0, 255, 255}, // cyan
  {255, 100, 0}, // orange
  {0, 100, 255}, // AMX Mod original info color!
  {0, 100, 255} // AMX Mod original info color!
}

new g_iColorNum

bool:bIsColorValue(const szText[], id) {
  for(new a = 0; a < MAX_COLORS; a++) {
    if(equali(szText, _T(g_szColorsNames[a], id)) || equali(szText, g_szColorsNames[a])) {
      g_iColorNum = a
      return true
    }
  }
  return false
}

enum eColors {
  szRed[4],
  szGreen[4],
  szBlue[4]
}

public cmdGlow(id, iLevel, iCommandId) {
  if(!cmd_access(id, iLevel, iCommandId, 3))
    return PLUGIN_HANDLED

  new szTarget[32], szColor[12], szAlpha[4], szColorFormat[32], iPlayer
  new iRed, iGreen, iBlue, iAlpha
  read_argv(1, szTarget, charsmax(szTarget))
  read_argv(2, szColor, charsmax(szColor))
  new iStatus = (szColor[0] == 'i' || szColor[0] == 'I') ? 2 :
  ((szColor[0] == 'n' || szColor[0] == 'N') ? 3 : 1)
  new bool:bHasSupreme = bool:(get_user_flags(id) & ADMIN_SUPREME)
  new szAdminName[32], szPlayerName[32]
  if(id == 0) szAdminName = "SERVER"
  else get_user_name(id, szAdminName, charsmax(szAdminName))

  #if defined USE_LOGS
  new szAdminAuthid[24], szAdminIpAddress[24]
  get_user_authid(id, szAdminAuthid, charsmax(szAdminAuthid))
  get_user_ip(id, szAdminIpAddress, charsmax(szAdminIpAddress), 1)
  #endif

  if(iStatus == 1) {
    if(szColor[0] == '!' && szColor[9]) {
      new szColors[eColors]
      copy(szColors[szRed], charsmax(szColors[szRed]), szColor[1])
      copy(szColors[szGreen], charsmax(szColors[szGreen]), szColor[4])
      copy(szColors[szBlue], charsmax(szColors[szBlue]), szColor[7])
      iRed   = str_to_num(szColors[szRed])
      iGreen = str_to_num(szColors[szGreen])
      iBlue  = str_to_num(szColors[szBlue])
    }
    else if(bIsColorValue(szColor, id)) {
      iRed    = g_iColorsValues[g_iColorNum][0]
      iGreen  = g_iColorsValues[g_iColorNum][1]
      iBlue   = g_iColorsValues[g_iColorNum][2]
      iStatus = 0
    }
    else {
      iRed   = random_num(0, 255)
      iGreen = random_num(0, 255)
      iBlue  = random_num(0, 255)
    }
  }
  iAlpha = (iStatus > 1) ? 0 : (read_argv(3, szAlpha, charsmax(szAlpha)) ? str_to_num(szAlpha) : 16)
  switch(iStatus) {
    case 0: copy(szColorFormat, charsmax(szColorFormat), _T(g_szColorsNames[g_iColorNum], id))
    case 1: formatex(szColorFormat, charsmax(szColorFormat), _T("RGB values: %d %d %d", id), iRed, iGreen, iBlue)
    case 2, 3: copy(szColorFormat, charsmax(szColorFormat), (iStatus == 2) ? _T("invisible", id) : _T("normal", id))
  }

  if(szTarget[0] == '*') {
    new iPlayers[32], iPlayersNum, iBlockedPlayersNum
    get_players(iPlayers, iPlayersNum, "ah")
    if(iPlayersNum > 0) {
      for(new i = 0; i < iPlayersNum; i++) {
        iPlayer = iPlayers[i]
        if((iPlayer != id) && (bHasSupreme == false) && (get_user_flags(iPlayer) & ADMIN_IMMUNITY)) {
          get_user_name(iPlayer, szPlayerName, charsmax(szPlayerName))
          console_print(id, _T("Player ^"%s^" has immunity."), szPlayerName)
          iBlockedPlayersNum++
          continue
        }
        switch(iStatus) {
          case 0, 1: set_user_rendering(iPlayer, kRenderFxGlowShell, iRed, iGreen, iBlue, kRenderNormal, iAlpha)
          case 2: set_user_rendering(iPlayer, kRenderFxGlowShell, 0, 0, 0, kRenderTransAlpha, iAlpha)
          case 3: set_user_rendering(iPlayer, kRenderFxGlowShell, 0, 0, 0, kRenderNormal, iAlpha)
        }
      }

      if(iBlockedPlayersNum == iPlayersNum) {
        console_print(id, _T("That action can't be performed on selected players."))
        return PLUGIN_HANDLED
      }

      #if defined USE_LOGS
      log_amx("KZ Multiplugin: ^"%s<%d><%s><%s>^" make all players %s (%s)",
      szAdminName, get_user_userid(id), szAdminAuthid, szAdminIpAddress, (iStatus == 3) ? "unglow" : "glow",
      (iStatus == 2) ? "invisible" : ((iStatus == 3) ? "normal" : ((iStatus == 1) ? "RGB values: %d %d %d" : g_szColorsNames[g_iColorNum])))
      #endif

      #if !defined COLORED_ACTIVITY
      show_activity(id, szAdminName, _T("make all players %s."), (iStatus == 3) ? _T("unglow") : _T("glow"))
      #else
      show_activity_color(id, szAdminName, _T("make all players %s."), (iStatus == 3) ? _T("unglow") : _T("glow"))
      #endif
      if(iStatus < 3) console_print(id, _T("All players are now glowing (%s)."), szColorFormat)
      else console_print(id, _T("All players are not glowing anymore (%s)."), szColorFormat)
    }
    else {
      console_print(id, _T("No alive player on the server."))
    }
  }
  else if(szTarget[0] == '@') {
    new iPlayers[32], iPlayersNum, iBlockedPlayersNum
    get_players(iPlayers, iPlayersNum, "aegh", szTarget[1])
    if(iPlayersNum > 0) {
      for(new i = 0; i < iPlayersNum; i++) {
        iPlayer = iPlayers[i]
        if((iPlayer != id) && (bHasSupreme == false) && (get_user_flags(iPlayer) & ADMIN_IMMUNITY)) {
          get_user_name(iPlayer, szPlayerName, charsmax(szPlayerName))
          console_print(id, _T("Player ^"%s^" has immunity."), szPlayerName)
          iBlockedPlayersNum++
          continue
        }
        switch(iStatus) {
          case 0, 1: set_user_rendering(iPlayer, kRenderFxGlowShell, iRed, iGreen, iBlue, kRenderNormal, iAlpha)
          case 2: set_user_rendering(iPlayer, kRenderFxGlowShell, 0, 0, 0, kRenderTransAlpha, iAlpha)
          case 3: set_user_rendering(iPlayer, kRenderFxGlowShell, 0, 0, 0, kRenderNormal, iAlpha)
        }
      }

      if(iBlockedPlayersNum == iPlayersNum) {
        console_print(id, _T("That action can't be performed on selected players."))
        return PLUGIN_HANDLED
      }

      new szTeamName[12]
      switch(szTarget[1]) {
        case '1', 't', 'T': copy(szTeamName, charsmax(szTeamName), "TERRORISTS")
        case '2', 'c', 'C': copy(szTeamName, charsmax(szTeamName), "CTs")
      }

      #if defined USE_LOGS
      log_amx("KZ Multiplugin: ^"%s<%d><%s><%s>^" make the %s %s (%s)",
      szAdminName, get_user_userid(id), szAdminAuthid, szAdminIpAddress, szTeamName, (iStatus == 3) ? "unglow" : "glow",
      (iStatus == 2) ? "invisible" : ((iStatus == 3) ? "normal" : ((iStatus == 1) ? "RGB values: %d %d %d" : g_szColorsNames[g_iColorNum])))
      #endif

      #if !defined COLORED_ACTIVITY
      if(iStatus < 3) show_activity(id, szAdminName, _T("make the %s glow."), _T(szTeamName))
      else show_activity(id, szAdminName, _T("make the %s unglow."), _T(szTeamName))
      #else
      if(iStatus < 3) show_activity_color(id, szAdminName, _T("make the %s glow."), _T(szTeamName))
      else show_activity_color(id, szAdminName, _T("make the %s unglow."), _T(szTeamName))
      #endif
      if(iStatus < 3) console_print(id, _T("The %s are now glowing (%s)."), _T(szTeamName), szColorFormat)
      else console_print(id, _T("The %s are not glowing anymore (%s)."), _T(szTeamName), szColorFormat)
    }
    else {
      console_print(id, _T("No alive player in this team."))
    }
  }
  else {
    iPlayer = cmd_target(id, szTarget, 7)
    if(!iPlayer)
      return PLUGIN_HANDLED

    switch(iStatus) {
      case 0, 1: set_user_rendering(iPlayer, kRenderFxGlowShell, iRed, iGreen, iBlue, kRenderNormal, iAlpha)
      case 2: set_user_rendering(iPlayer, kRenderFxGlowShell, 0, 0, 0, kRenderTransAlpha, iAlpha)
      case 3: set_user_rendering(iPlayer, kRenderFxGlowShell, 0, 0, 0, kRenderNormal, iAlpha)
    }

    get_user_name(iPlayer, szPlayerName, charsmax(szPlayerName))

    #if defined USE_LOGS
    new szPlayerAuthid[24], szPlayerIpAddress[24]
    get_user_authid(iPlayer, szPlayerAuthid, charsmax(szPlayerAuthid))
    get_user_ip(iPlayer, szPlayerIpAddress, charsmax(szPlayerIpAddress), 1)
    log_amx("KZ Multiplugin: ^"%s<%d><%s><%s>^" make ^"%s<%d><%s><%s>^" %s (%s)",
    szAdminName, get_user_userid(id), szAdminAuthid, szAdminIpAddress,
    szPlayerName, get_user_userid(iPlayer), szPlayerAuthid, szPlayerIpAddress, (iStatus == 3) ? "unglow" : "glow",
    (iStatus == 2) ? "invisible" : ((iStatus == 3) ? "normal" : ((iStatus == 1) ? "RGB values: %d %d %d" : g_szColorsNames[g_iColorNum])))
    #endif

    #if !defined COLORED_ACTIVITY
    if(iStatus < 3) show_activity(id, szAdminName, _T("make %s glow."), szPlayerName)
    else show_activity(id, szAdminName, _T("make %s unglow."), szPlayerName)
    #else
    if(iStatus < 3) show_activity_color(id, szAdminName, _T("make %s glow."), szPlayerName)
    else show_activity_color(id, szAdminName, _T("make %s unglow."), szPlayerName)
    #endif
    if(iStatus < 3) console_print(id, _T("Player ^"%s^" is now glowing (%s)."), szPlayerName, szColorFormat)
    else console_print(id, _T("Player ^"%s^" is not glowing anymore (%s)."), szPlayerName, szColorFormat)
  }
  return PLUGIN_HANDLED
}

// Admin Godmode
public cmdGodmode(id, iLevel, iCommandId) {
  if(!cmd_access(id, iLevel, iCommandId, 3))
    return PLUGIN_HANDLED

  new szTarget[32], szStatus[2], iPlayer
  read_argv(1, szTarget, charsmax(szTarget))
  read_argv(2, szStatus, charsmax(szStatus))
  new iGodStatus = str_to_num(szStatus) ? 1 : 0
  new bool:bHasSupreme = bool:(get_user_flags(id) & ADMIN_SUPREME)
  new szAdminName[32], szPlayerName[32]
  if(id == 0) szAdminName = "SERVER"
  else get_user_name(id, szAdminName, charsmax(szAdminName))

  #if defined USE_LOGS
  new szAdminAuthid[24], szAdminIpAddress[24]
  get_user_authid(id, szAdminAuthid, charsmax(szAdminAuthid))
  get_user_ip(id, szAdminIpAddress, charsmax(szAdminIpAddress), 1)
  #endif

  if(szTarget[0] == '*') {
    new iPlayers[32], iPlayersNum, iBlockedPlayersNum
    get_players(iPlayers, iPlayersNum, "ah")
    if(iPlayersNum > 0) {
      for(new i = 0; i < iPlayersNum; i++) {
        iPlayer = iPlayers[i]
        if((iPlayer != id) && (bHasSupreme == false) && (get_user_flags(iPlayer) & ADMIN_IMMUNITY)) {
          get_user_name(iPlayer, szPlayerName, charsmax(szPlayerName))
          console_print(id, _T("Player ^"%s^" has immunity."), szPlayerName)
          iBlockedPlayersNum++
          continue
        }
        set_user_godmode(iPlayer, iGodStatus)
      }

      if(iBlockedPlayersNum == iPlayersNum) {
        console_print(id, _T("That action can't be performed on selected players."))
        return PLUGIN_HANDLED
      }

      #if defined USE_LOGS
      if(iGodStatus) log_amx("KZ Multiplugin: ^"%s<%d><%s><%s>^" give godmode to all players",
      szAdminName, get_user_userid(id), szAdminAuthid, szAdminIpAddress)
      else log_amx("KZ Multiplugin: ^"%s<%d><%s><%s>^" remove godmode from all players",
      szAdminName, get_user_userid(id), szAdminAuthid, szAdminIpAddress)
      #endif

      #if !defined COLORED_ACTIVITY
      if(iGodStatus) show_activity(id, szAdminName, _T("give godmode to all players."))
      else show_activity(id, szAdminName, _T("remove godmode from all players."))
      #else
      if(iGodStatus) show_activity_color(id, szAdminName, _T("give godmode to all players."))
      else show_activity_color(id, szAdminName, _T("remove godmode from all players."))
      #endif
      if(iGodStatus) console_print(id, _T("Godmode given to all players."))
      else console_print(id, _T("Godmode removed from all players."))
    }
    else {
      console_print(id, _T("No alive player on the server."))
    }
  }
  else if(szTarget[0] == '@') {
    new iPlayers[32], iPlayersNum, iBlockedPlayersNum
    get_players(iPlayers, iPlayersNum, "aegh", szTarget[1])
    if(iPlayersNum > 0) {
      for(new i = 0; i < iPlayersNum; i++) {
        iPlayer = iPlayers[i]
        if((iPlayer != id) && (bHasSupreme == false) && (get_user_flags(iPlayer) & ADMIN_IMMUNITY)) {
          get_user_name(iPlayer, szPlayerName, charsmax(szPlayerName))
          console_print(id, _T("Player ^"%s^" has immunity."), szPlayerName)
          iBlockedPlayersNum++
          continue
        }
        set_user_godmode(iPlayer, iGodStatus)
      }

      if(iBlockedPlayersNum == iPlayersNum) {
        console_print(id, _T("That action can't be performed on selected players."))
        return PLUGIN_HANDLED
      }

      new szTeamName[12]
      switch(szTarget[1]) {
        case '1', 't', 'T': copy(szTeamName, charsmax(szTeamName), "TERRORISTS")
        case '2', 'c', 'C': copy(szTeamName, charsmax(szTeamName), "CTs")
      }

      #if defined USE_LOGS
      if(iGodStatus) log_amx("KZ Multiplugin: ^"%s<%d><%s><%s>^" give godmode to the %s",
      szAdminName, get_user_userid(id), szAdminAuthid, szAdminIpAddress, szTeamName)
      else log_amx("KZ Multiplugin: ^"%s<%d><%s><%s>^" remove godmode from the %s",
      szAdminName, get_user_userid(id), szAdminAuthid, szAdminIpAddress, szTeamName)
      #endif

      #if !defined COLORED_ACTIVITY
      if(iGodStatus) show_activity(id, szAdminName, _T("give godmode to the %s."), _T(szTeamName))
      else show_activity(id, szAdminName, _T("remove godmode from the %s."), _T(szTeamName))
      #else
      if(iGodStatus) show_activity_color(id, szAdminName, _T("give godmode to the %s."), _T(szTeamName))
      else show_activity_color(id, szAdminName, _T("remove godmode from the %s."), _T(szTeamName))
      #endif
      if(iGodStatus) console_print(id, _T("Godmode given to the %s."), _T(szTeamName))
      else console_print(id, _T("Godmode removed from the %s."), _T(szTeamName))
    }
    else {
      console_print(id, _T("No alive player in this team."))
    }
  }
  else {
    iPlayer = cmd_target(id, szTarget, 7)
    if(!iPlayer)
      return PLUGIN_HANDLED

    set_user_godmode(iPlayer, iGodStatus)
    get_user_name(iPlayer, szPlayerName, charsmax(szPlayerName))

    #if defined USE_LOGS
    new szPlayerAuthid[24], szPlayerIpAddress[24]
    get_user_authid(iPlayer, szPlayerAuthid, charsmax(szPlayerAuthid))
    get_user_ip(iPlayer, szPlayerIpAddress, charsmax(szPlayerIpAddress), 1)
    if(iGodStatus) log_amx("KZ Multiplugin: ^"%s<%d><%s><%s>^" give godmode to ^"%s<%d><%s><%s>^"",
    szAdminName, get_user_userid(id), szAdminAuthid, szAdminIpAddress,
    szPlayerName, get_user_userid(iPlayer), szPlayerAuthid, szPlayerIpAddress)
    else log_amx("KZ Multiplugin: ^"%s<%d><%s><%s>^" remove godmode from ^"%s<%d><%s><%s>^"",
    szAdminName, get_user_userid(id), szAdminAuthid, szAdminIpAddress,
    szPlayerName, get_user_userid(iPlayer), szPlayerAuthid, szPlayerIpAddress)
    #endif

    #if !defined COLORED_ACTIVITY
    if(iGodStatus) show_activity(id, szAdminName, _T("give godmode to %s."), szPlayerName)
    else show_activity(id, szAdminName, _T("remove godmode from %s."), szPlayerName)
    #else
    if(iGodStatus) show_activity_color(id, szAdminName, _T("give godmode to %s."), szPlayerName)
    else show_activity_color(id, szAdminName, _T("remove godmode from %s."), szPlayerName)
    #endif
    if(iGodStatus) console_print(id, _T("Godmode given to %s."), szPlayerName)
    else console_print(id, _T("Godmode removed from %s."), szPlayerName)
  }
  return PLUGIN_HANDLED
}

// Admin Gravity
public cmdGravity(id, iLevel, iCommandId) {
  if(!cmd_access(id, iLevel, iCommandId, 3))
    return PLUGIN_HANDLED

  new szTarget[32], szGravity[8], iPlayer
  read_argv(1, szTarget, charsmax(szTarget))
  read_argv(2, szGravity, charsmax(szGravity))
  new Float:fGravity = equali(szGravity, "normal") ? 1.0 : (floatstr(szGravity) / 800)
  if(fGravity != 1.0 && !is_str_num(szGravity)) {
    console_print(id, _T("The gravity parameter must be a number!"))
    return PLUGIN_HANDLED
  }
  new bool:bHasSupreme = bool:(get_user_flags(id) & ADMIN_SUPREME)
  new szAdminName[32], szPlayerName[32]
  if(id == 0) szAdminName = "SERVER"
  else get_user_name(id, szAdminName, charsmax(szAdminName))

  #if defined USE_LOGS
  new szAdminAuthid[24], szAdminIpAddress[24]
  get_user_authid(id, szAdminAuthid, charsmax(szAdminAuthid))
  get_user_ip(id, szAdminIpAddress, charsmax(szAdminIpAddress), 1)
  #endif

  if(szTarget[0] == '*') {
    new iPlayers[32], iPlayersNum, iBlockedPlayersNum
    get_players(iPlayers, iPlayersNum, "ah")
    if(iPlayersNum > 0) {
      for(new i = 0; i < iPlayersNum; i++) {
        iPlayer = iPlayers[i]
        if((iPlayer != id) && (bHasSupreme == false) && (get_user_flags(iPlayer) & ADMIN_IMMUNITY)) {
          get_user_name(iPlayer, szPlayerName, charsmax(szPlayerName))
          console_print(id, _T("Player ^"%s^" has immunity."), szPlayerName)
          iBlockedPlayersNum++
          continue
        }
        set_user_gravity(iPlayer, fGravity)
        CheatDetect(iPlayer, "GravityChange")
      }

      if(iBlockedPlayersNum == iPlayersNum) {
        console_print(id, _T("That action can't be performed on selected players."))
        return PLUGIN_HANDLED
      }

      #if defined USE_LOGS
      log_amx("KZ Multiplugin: ^"%s<%d><%s><%s>^" change gravity of all players (gravity: %s)",
      szAdminName, get_user_userid(id), szAdminAuthid, szAdminIpAddress, szGravity)
      #endif

      #if !defined COLORED_ACTIVITY
      show_activity(id, szAdminName, _T("change gravity of all players."))
      #else
      show_activity_color(id, szAdminName, _T("change gravity of all players."))
      #endif
      console_print(id, _T("The gravity of all players has been changed (gravity: %s)."), szGravity)
    }
    else {
      console_print(id, _T("No alive player on the server."))
    }
  }
  else if(szTarget[0] == '@') {
    new iPlayers[32], iPlayersNum, iBlockedPlayersNum
    get_players(iPlayers, iPlayersNum, "aegh", szTarget[1])
    if(iPlayersNum > 0) {
      for(new i = 0; i < iPlayersNum; i++) {
        iPlayer = iPlayers[i]
        if((iPlayer != id) && (bHasSupreme == false) && (get_user_flags(iPlayer) & ADMIN_IMMUNITY)) {
          get_user_name(iPlayer, szPlayerName, charsmax(szPlayerName))
          console_print(id, _T("Player ^"%s^" has immunity."), szPlayerName)
          iBlockedPlayersNum++
          continue
        }
        set_user_gravity(iPlayer, fGravity)
        CheatDetect(iPlayer, "GravityChange")
      }

      if(iBlockedPlayersNum == iPlayersNum) {
        console_print(id, _T("That action can't be performed on selected players."))
        return PLUGIN_HANDLED
      }

      new szTeamName[12]
      switch(szTarget[1]) {
        case '1', 't', 'T': copy(szTeamName, charsmax(szTeamName), "TERRORISTS")
        case '2', 'c', 'C': copy(szTeamName, charsmax(szTeamName), "CTs")
      }

      #if defined USE_LOGS
      log_amx("KZ Multiplugin: ^"%s<%d><%s><%s>^" change gravity of the %s (gravity: %s)",
      szAdminName, get_user_userid(id), szAdminAuthid, szAdminIpAddress, szTeamName, szGravity)
      #endif

      #if !defined COLORED_ACTIVITY
      show_activity(id, szAdminName, _T("change gravity of the %s."), _T(szTeamName))
      #else
      show_activity_color(id, szAdminName, _T("change gravity of the %s."), _T(szTeamName))
      #endif
      console_print(id, _T("The gravity of the %s has been changed (gravity: %s)."), _T(szTeamName), szGravity)
    }
    else {
      console_print(id, _T("No alive player in this team."))
    }
  }
  else {
    iPlayer = cmd_target(id, szTarget, 7)
    if(!iPlayer)
      return PLUGIN_HANDLED

    set_user_gravity(iPlayer, fGravity)
    CheatDetect(iPlayer, "GravityChange")
    get_user_name(iPlayer, szPlayerName, charsmax(szPlayerName))

    #if defined USE_LOGS
    new szPlayerAuthid[24], szPlayerIpAddress[24]
    get_user_authid(iPlayer, szPlayerAuthid, charsmax(szPlayerAuthid))
    get_user_ip(iPlayer, szPlayerIpAddress, charsmax(szPlayerIpAddress), 1)
    log_amx("KZ Multiplugin: ^"%s<%d><%s><%s>^" change gravity of ^"%s<%d><%s><%s>^" (gravity: %s)",
    szAdminName, get_user_userid(id), szAdminAuthid, szAdminIpAddress,
    szPlayerName, get_user_userid(iPlayer), szPlayerAuthid, szPlayerIpAddress, szGravity)
    #endif

    #if !defined COLORED_ACTIVITY
    show_activity(id, szAdminName, _T("change gravity of %s."), szPlayerName)
    #else
    show_activity_color(id, szAdminName, _T("change gravity of %s."), szPlayerName)
    #endif
    console_print(id, _T("The gravity of %s has been changed (gravity: %s)."), szPlayerName, szGravity)
  }
  return PLUGIN_HANDLED
}

// Admin Money
public cmdMoney(id, iLevel, iCommandId) {
  if(!cmd_access(id, iLevel, iCommandId, 3))
    return PLUGIN_HANDLED

  new szTarget[32], szMoney[8], iPlayer
  read_argv(1, szTarget, charsmax(szTarget))
  read_argv(2, szMoney, charsmax(szMoney))
  new iMoney = str_to_num(szMoney)
  new bool:bRemoveStatus = bool:(szMoney[0] == '-')
  if(!bRemoveStatus && !(0 < iMoney < 16001)) {
    console_print(id, _T("The money parameter must be between 1 and 16000!"))
    return PLUGIN_HANDLED
  }
  new bool:bHasSupreme = bool:(get_user_flags(id) & ADMIN_SUPREME)
  new szAdminName[32], szPlayerName[32]
  if(id == 0) szAdminName = "SERVER"
  else get_user_name(id, szAdminName, charsmax(szAdminName))

  #if defined USE_LOGS
  new szAdminAuthid[24], szAdminIpAddress[24]
  get_user_authid(id, szAdminAuthid, charsmax(szAdminAuthid))
  get_user_ip(id, szAdminIpAddress, charsmax(szAdminIpAddress), 1)
  #endif

  if(szTarget[0] == '*') {
    new iPlayers[32], iPlayersNum, iBlockedPlayersNum
    get_players(iPlayers, iPlayersNum, "ch")
    if(iPlayersNum > 0) {
      for(new i = 0; i < iPlayersNum; i++) {
        iPlayer = iPlayers[i]
        if((iPlayer != id) && (bHasSupreme == false) && (get_user_flags(iPlayer) & ADMIN_IMMUNITY)) {
          get_user_name(iPlayer, szPlayerName, charsmax(szPlayerName))
          console_print(id, _T("Player ^"%s^" has immunity."), szPlayerName)
          iBlockedPlayersNum++
          continue
        }
        cs_set_user_money(iPlayer, clamp(cs_get_user_money(iPlayer) + iMoney, 0, 16000))
      }
      if(iBlockedPlayersNum == iPlayersNum) {
        console_print(id, _T("That action can't be performed on selected players."))
        return PLUGIN_HANDLED
      }

      #if defined USE_LOGS
      if(!bRemoveStatus) log_amx("KZ Multiplugin: ^"%s<%d><%s><%s>^" give money to all players ($%d)",
      szAdminName, get_user_userid(id), szAdminAuthid, szAdminIpAddress, iMoney)
      else log_amx("KZ Multiplugin: ^"%s<%d><%s><%s>^" remove money from all players ($%d)",
      szAdminName, get_user_userid(id), szAdminAuthid, szAdminIpAddress, iMoney)
      #endif

      #if !defined COLORED_ACTIVITY
      if(!bRemoveStatus) show_activity(id, szAdminName, _T("give money to all players."))
      else show_activity(id, szAdminName, _T("remove money from all players."))
      #else
      if(!bRemoveStatus) show_activity_color(id, szAdminName, _T("give money to all players."))
      else show_activity_color(id, szAdminName, _T("remove money from all players."))
      #endif
      if(!bRemoveStatus) console_print(id, _T("Money given to all players ($%d)."), iMoney)
      else console_print(id, _T("Money removed from all players ($%d)."), iMoney)
    }
    else {
      console_print(id, _T("No real player on the server."))
    }
  }
  else if(szTarget[0] == '@') {
    new iPlayers[32], iPlayersNum, iBlockedPlayersNum
    get_players(iPlayers, iPlayersNum, "cegh", szTarget[1])
    if(iPlayersNum > 0) {
      for(new i = 0; i < iPlayersNum; i++) {
        iPlayer = iPlayers[i]
        if((iPlayer != id) && (bHasSupreme == false) && (get_user_flags(iPlayer) & ADMIN_IMMUNITY)) {
          get_user_name(iPlayer, szPlayerName, charsmax(szPlayerName))
          console_print(id, _T("Player ^"%s^" has immunity."), szPlayerName)
          iBlockedPlayersNum++
          continue
        }
        cs_set_user_money(iPlayer, clamp(cs_get_user_money(iPlayer) + iMoney, 0, 16000))
      }

      if(iBlockedPlayersNum == iPlayersNum) {
        console_print(id, _T("That action can't be performed on selected players."))
        return PLUGIN_HANDLED
      }

      new szTeamName[12]
      switch(szTarget[1]) {
        case '0', 'u', 'U': copy(szTeamName, charsmax(szTeamName), "UNASSIGNED")
        case '1', 't', 'T': copy(szTeamName, charsmax(szTeamName), "TERRORISTS")
        case '2', 'c', 'C': copy(szTeamName, charsmax(szTeamName), "CTs")
        case '3', 's', 'S': copy(szTeamName, charsmax(szTeamName), "SPECTATORS")
      }

      #if defined USE_LOGS
      if(!bRemoveStatus) log_amx("KZ Multiplugin: ^"%s<%d><%s><%s>^" give money to the %s ($%d)",
      szAdminName, get_user_userid(id), szAdminAuthid, szAdminIpAddress, szTeamName, iMoney)
      else log_amx("KZ Multiplugin: ^"%s<%d><%s><%s>^" remove money from the %s ($%d)",
      szAdminName, get_user_userid(id), szAdminAuthid, szAdminIpAddress, szTeamName, iMoney)
      #endif

      #if !defined COLORED_ACTIVITY
      if(!bRemoveStatus) show_activity(id, szAdminName, _T("give money to the %s."), _T(szTeamName))
      else show_activity(id, szAdminName, _T("remove money from the %s."), _T(szTeamName))
      #else
      if(!bRemoveStatus) show_activity_color(id, szAdminName, _T("give money to the %s."), _T(szTeamName))
      else show_activity_color(id, szAdminName, _T("remove money from the %s."), _T(szTeamName))
      #endif
      if(!bRemoveStatus) console_print(id, _T("Money given to the %s ($%d)."), _T(szTeamName), iMoney)
      else console_print(id, _T("Money removed from the %s ($%d)."), _T(szTeamName), iMoney)
    }
    else {
      console_print(id, _T("No real player in this team."))
    }
  }
  else {
    iPlayer = cmd_target(id, szTarget, 11)
    if(!iPlayer)
      return PLUGIN_HANDLED

    cs_set_user_money(iPlayer, clamp(cs_get_user_money(iPlayer) + iMoney, 0, 16000))
    get_user_name(iPlayer, szPlayerName, charsmax(szPlayerName))

    #if defined USE_LOGS
    new szPlayerAuthid[24], szPlayerIpAddress[24]
    get_user_authid(iPlayer, szPlayerAuthid, charsmax(szPlayerAuthid))
    get_user_ip(iPlayer, szPlayerIpAddress, charsmax(szPlayerIpAddress), 1)
    if(!bRemoveStatus) log_amx("KZ Multiplugin: ^"%s<%d><%s><%s>^" give money to ^"%s<%d><%s><%s>^" ($%d)",
    szAdminName, get_user_userid(id), szAdminAuthid, szAdminIpAddress,
    szPlayerName, get_user_userid(iPlayer), szPlayerAuthid, szPlayerIpAddress, iMoney)
    else log_amx("KZ Multiplugin: ^"%s<%d><%s><%s>^" remove money from ^"%s<%d><%s><%s>^" ($%d)",
    szAdminName, get_user_userid(id), szAdminAuthid, szAdminIpAddress,
    szPlayerName, get_user_userid(iPlayer), szPlayerAuthid, szPlayerIpAddress, iMoney)
    #endif

    #if !defined COLORED_ACTIVITY
    if(!bRemoveStatus) show_activity(id, szAdminName, _T("give money to %s."), szPlayerName)
    else show_activity(id, szAdminName, _T("remove money from %s."), szPlayerName)
    #else
    if(!bRemoveStatus) show_activity_color(id, szAdminName, _T("give money to %s."), szPlayerName)
    else show_activity_color(id, szAdminName, _T("remove money from %s."), szPlayerName)
    #endif
    if(!bRemoveStatus) console_print(id, _T("Money given to %s ($%d)."), szPlayerName, iMoney)
    else console_print(id, _T("Money removed from %s ($%d)."), szPlayerName, iMoney)
  }
  return PLUGIN_HANDLED
}

// Admin Noclip
public cmdNoclip(id, iLevel, iCommandId) {
  if(!cmd_access(id, iLevel, iCommandId, 3))
    return PLUGIN_HANDLED

  new szTarget[32], szStatus[2], iPlayer
  read_argv(1, szTarget, charsmax(szTarget))
  read_argv(2, szStatus, charsmax(szStatus))
  new bool:bNoclipStatus = bool:str_to_num(szStatus)
  new bool:bHasSupreme = bool:(get_user_flags(id) & ADMIN_SUPREME)
  new szAdminName[32], szPlayerName[32]
  if(id == 0) szAdminName = "SERVER"
  else get_user_name(id, szAdminName, charsmax(szAdminName))

  #if defined USE_LOGS
  new szAdminAuthid[24], szAdminIpAddress[24]
  get_user_authid(id, szAdminAuthid, charsmax(szAdminAuthid))
  get_user_ip(id, szAdminIpAddress, charsmax(szAdminIpAddress), 1)
  #endif

  if(szTarget[0] == '*') {
    new iPlayers[32], iPlayersNum, iBlockedPlayersNum
    get_players(iPlayers, iPlayersNum, "ach")
    if(iPlayersNum > 0) {
      for(new i = 0; i < iPlayersNum; i++) {
        iPlayer = iPlayers[i]
        if((iPlayer != id) && (bHasSupreme == false) && (get_user_flags(iPlayer) & ADMIN_IMMUNITY)) {
          get_user_name(iPlayer, szPlayerName, charsmax(szPlayerName))
          console_print(id, _T("Player ^"%s^" has immunity."), szPlayerName)
          iBlockedPlayersNum++
          continue
        }
        set_user_noclip(iPlayer, bNoclipStatus)
        CheatDetect(iPlayer, "NoClip")
      }

      if(iBlockedPlayersNum == iPlayersNum) {
        console_print(id, _T("That action can't be performed on selected players."))
        return PLUGIN_HANDLED
      }

      #if defined USE_LOGS
      if(bNoclipStatus) log_amx("KZ Multipluginp: ^"%s<%d><%s><%s>^" give noclip to all players",
      szAdminName, get_user_userid(id), szAdminAuthid, szAdminIpAddress)
      else log_amx("KZ Multiplugin: ^"%s<%d><%s><%s>^" remove noclip from all players",
      szAdminName, get_user_userid(id), szAdminAuthid, szAdminIpAddress)
      #endif

      #if !defined COLORED_ACTIVITY
      if(bNoclipStatus) show_activity(id, szAdminName, _T("give noclip to all players."))
      else show_activity(id, szAdminName, _T("remove noclip from all players."))
      #else
      if(bNoclipStatus) show_activity_color(id, szAdminName, _T("give noclip to all players."))
      else show_activity_color(id, szAdminName, _T("remove noclip from all players."))
      #endif
      if(bNoclipStatus) console_print(id, _T("Noclip given to all players."))
      else console_print(id, _T("Noclip removed from all players."))
    }
    else {
      console_print(id, _T("No real alive player on the server."))
    }
  }
  else if(szTarget[0] == '@') {
    new iPlayers[32], iPlayersNum, iBlockedPlayersNum
    get_players(iPlayers, iPlayersNum, "acegh", szTarget[1])
    if(iPlayersNum > 0) {
      for(new i = 0; i < iPlayersNum; i++) {
        iPlayer = iPlayers[i]
        if((iPlayer != id) && (bHasSupreme == false) && (get_user_flags(iPlayer) & ADMIN_IMMUNITY)) {
          get_user_name(iPlayer, szPlayerName, charsmax(szPlayerName))
          console_print(id, _T("Player ^"%s^" has immunity."), szPlayerName)
          iBlockedPlayersNum++
          continue
        }
        set_user_noclip(iPlayer, bNoclipStatus)
        CheatDetect(iPlayer, "NoClip")
      }

      if(iBlockedPlayersNum == iPlayersNum) {
        console_print(id, _T("That action can't be performed on selected players."))
        return PLUGIN_HANDLED
      }

      new szTeamName[12]
      switch(szTarget[1]) {
        case '1', 't', 'T': copy(szTeamName, charsmax(szTeamName), "TERRORISTS")
        case '2', 'c', 'C': copy(szTeamName, charsmax(szTeamName), "CTs")
      }

      #if defined USE_LOGS
      if(bNoclipStatus) log_amx("KZ Multiplugin: ^"%s<%d><%s><%s>^" give noclip to the %s",
      szAdminName, get_user_userid(id), szAdminAuthid, szAdminIpAddress, szTeamName)
      else log_amx("KZ Multiplugin: ^"%s<%d><%s><%s>^" remove noclip from the %s",
      szAdminName, get_user_userid(id), szAdminAuthid, szAdminIpAddress, szTeamName)
      #endif

      #if !defined COLORED_ACTIVITY
      if(bNoclipStatus) show_activity(id, szAdminName, _T("give noclip to the %s."), _T(szTeamName))
      else show_activity(id, szAdminName, _T("remove noclip from the %s."), _T(szTeamName))
      #else
      if(bNoclipStatus) show_activity_color(id, szAdminName, _T("give noclip to the %s."), _T(szTeamName))
      else show_activity_color(id, szAdminName, _T("remove noclip from the %s."), _T(szTeamName))
      #endif
      if(bNoclipStatus) console_print(id, _T("Noclip given to the %s."), _T(szTeamName))
      else console_print(id, _T("Noclip removed from the %s."), _T(szTeamName))
    }
    else {
      console_print(id, _T("No real alive player in this team."))
    }
  }
  else {
    iPlayer = cmd_target(id, szTarget, 15)
    if(!iPlayer)
      return PLUGIN_HANDLED

    set_user_noclip(iPlayer, bNoclipStatus)
    CheatDetect(iPlayer, "NoClip")
    get_user_name(iPlayer, szPlayerName, charsmax(szPlayerName))

    #if defined USE_LOGS
    new szPlayerAuthid[24], szPlayerIpAddress[24]
    get_user_authid(iPlayer, szPlayerAuthid, charsmax(szPlayerAuthid))
    get_user_ip(iPlayer, szPlayerIpAddress, charsmax(szPlayerIpAddress), 1)
    if(bNoclipStatus) log_amx("KZ Multiplugin: ^"%s<%d><%s><%s>^" give noclip to ^"%s<%d><%s><%s>^"",
    szAdminName, get_user_userid(id), szAdminAuthid, szAdminIpAddress,
    szPlayerName, get_user_userid(iPlayer), szPlayerAuthid, szPlayerIpAddress)
    else log_amx("KZ Multiplugin: ^"%s<%d><%s><%s>^" remove noclip from ^"%s<%d><%s><%s>^"",
    szAdminName, get_user_userid(id), szAdminAuthid, szAdminIpAddress,
    szPlayerName, get_user_userid(iPlayer), szPlayerAuthid, szPlayerIpAddress)
    #endif

    #if !defined COLORED_ACTIVITY
    if(bNoclipStatus) show_activity(id, szAdminName, _T("give noclip to %s."), szPlayerName)
    else show_activity(id, szAdminName, _T("remove noclip from %s."), szPlayerName)
    #else
    if(bNoclipStatus) show_activity_color(id, szAdminName, _T("give noclip to %s."), szPlayerName)
    else show_activity_color(id, szAdminName, _T("remove noclip from %s."), szPlayerName)
    #endif
    if(bNoclipStatus) console_print(id, _T("Noclip given to %s."), szPlayerName)
    else console_print(id, _T("Noclip removed from %s."), szPlayerName)
  }
  return PLUGIN_HANDLED
}

// Admin Teleport
new g_iStoredOrigin[33][3]

public cmdTeleport(id, iLevel, iCommandId) {
  if(!cmd_access(id, iLevel, iCommandId, 2))
    return PLUGIN_HANDLED

  new szTarget[32], iCoord[3][8], iOrigin[3]
  read_argv(1, szTarget, charsmax(szTarget))
  if(read_argc() > 2) {
    read_argv(2, iCoord[0], charsmax(iCoord[]))
    read_argv(3, iCoord[1], charsmax(iCoord[]))
    read_argv(4, iCoord[2], charsmax(iCoord[]))
    iOrigin[0] = str_to_num(iCoord[0])
    iOrigin[1] = str_to_num(iCoord[1])
    iOrigin[2] = str_to_num(iCoord[2])
  }
  else {
    iOrigin = g_iStoredOrigin[id]
  }

  new iPlayer = cmd_target(id, szTarget, 7)
  if(!iPlayer)
    return PLUGIN_HANDLED

  set_user_origin(iPlayer, iOrigin)
  CheatDetect(iPlayer, "Teleport")

  new szAdminName[32], szPlayerName[32]
  if(id == 0) szAdminName = "SERVER"
  else get_user_name(id, szAdminName, charsmax(szAdminName))
  get_user_name(iPlayer, szPlayerName, charsmax(szPlayerName))

  #if defined USE_LOGS
  new szAdminAuthid[24], szAdminIpAddress[24], szPlayerAuthid[24], szPlayerIpAddress[24]
  get_user_authid(id, szAdminAuthid, charsmax(szAdminAuthid))
  get_user_ip(id, szAdminIpAddress, charsmax(szAdminIpAddress))
  get_user_authid(iPlayer, szPlayerAuthid, charsmax(szPlayerAuthid))
  get_user_ip(iPlayer, szPlayerIpAddress, charsmax(szPlayerIpAddress))
  log_amx("KZ Multiplugin: ^"%s<%d><%s><%s>^" teleport ^"%s<%d><%s><%s>^" to coordinates: %d %d %d",
  szAdminName, get_user_userid(id), szAdminAuthid, szAdminIpAddress,
  szPlayerName, get_user_userid(iPlayer), szPlayerAuthid, szPlayerIpAddress, iOrigin[0], iOrigin[1], iOrigin[2])
  #endif

  #if !defined COLORED_ACTIVITY
  show_activity(id, szAdminName, _T("teleport %s."), szPlayerName)
  #else
  show_activity_color(id, szAdminName, _T("teleport %s."), szPlayerName)
  #endif
  console_print(id, _T("Player ^"%s^" teleported to coordinates: %d %d %d"), szPlayerName, iOrigin[0], iOrigin[1], iOrigin[2])
  return PLUGIN_HANDLED
}

public cmdUserOrigin(id, iLevel, iCommandId) {
  if(!cmd_access(id, iLevel, iCommandId, 2))
    return PLUGIN_HANDLED

  new szTarget[32]
  read_argv(1, szTarget, charsmax(szTarget))
  new iPlayer = cmd_target(id, szTarget, 7)
  if(!iPlayer)
    return PLUGIN_HANDLED

  new iOrigin[3]
  get_user_origin(iPlayer, iOrigin)
  iOrigin[2] += 2
  g_iStoredOrigin[id] = iOrigin
  new szPlayerName[32]
  get_user_name(iPlayer, szPlayerName, charsmax(szPlayerName))

  #if defined USE_LOGS
  new szAdminName[32], szAdminAuthid[24], szAdminIpAddress[24], szPlayerAuthid[24], szPlayerIpAddress[24]
  if(id == 0) szAdminName = "SERVER"
  else get_user_name(id, szAdminName, charsmax(szAdminName))
  get_user_authid(id, szAdminAuthid, charsmax(szAdminAuthid))
  get_user_ip(id, szAdminIpAddress, charsmax(szAdminIpAddress))
  get_user_authid(iPlayer, szPlayerAuthid, charsmax(szPlayerAuthid))
  get_user_ip(iPlayer, szPlayerIpAddress, charsmax(szPlayerIpAddress))
  log_amx("KZ Multiplugin: ^"%s<%d><%s><%s>^" ask the position (origin) of ^"%s<%d><%s><%s>^" (%d %d %d)",
  szAdminName, get_user_userid(id), szAdminAuthid, szAdminIpAddress,
  szPlayerName, get_user_userid(iPlayer), szPlayerAuthid, szPlayerIpAddress, iOrigin[0], iOrigin[1], iOrigin[2])
  #endif

  console_print(id, _T("Position of %s is: %d %d %d"), szPlayerName, iOrigin[0], iOrigin[1], iOrigin[2])
  return PLUGIN_HANDLED
}

/************************************************************************************************************************/
/******************************************************* JEDIGRAB *******************************************************/
/************************************************************************************************************************/

new grabbed[33]
new grablength[33]
new velocity_multiplier
#define TASKID_GRABTASK 124

public grab_toggle(id, level)
{
	if (grabmodeon & (1<<(id&31)))
		release(id, level)
	else
		grab(id, level)

	return PLUGIN_HANDLED
}

public grab(id, level)
{
	if (!access(id, level))
	{
		console_print(id, _T("You have no access to that command."))
		client_print(id, print_chat, _T("You have no access to that command."))
		return PLUGIN_HANDLED
	}

	if (~grabmodeon & (1<<(id&31)))
	{
		grabmodeon |= (1<<(id&31))
		velocity_multiplier = get_cvarptr_num(g_cvar_sv_grabforce)

		set_task(0.1, "grabtask", TASKID_GRABTASK+id, _,_, "b")
	}

	return PLUGIN_HANDLED
}

public release(id,level)
{
	if (!access(id, level))
	{
		console_print(id, _T("You have no access to that command."))
		client_print(id, print_chat, _T("You have no access to that command."))
		if(grabmodeon & (1<<(id&31))) // if you remove adminflags during a grab
			goto disablegrab

		return PLUGIN_HANDLED
	}

	disablegrab:
	if (grabmodeon & (1<<(id&31)))
	{
		grabmodeon &= ~(1<<(id&31))
		if (grabbed[id] > 0)
		{
			new targname[32]
			set_user_gravity(grabbed[id])
			set_user_rendering(grabbed[id])
			get_user_name(grabbed[id],targname,31)
			grabbed[id]=0
		}
		else
		{
			client_print(id, print_chat, _T("No target found..."))
		}
		remove_task(TASKID_GRABTASK+id)
	}

	return PLUGIN_HANDLED
}

public grabtask(id) {
	id -= TASKID_GRABTASK

	static targetid, body

	if (grabbed[id])
	{
		static origin[3]
		static look[3]
		static direction[3]
		static moveto[3]
		static grabbedorigin[3]
		static velocity[3]
		static Float:fVelocity[3]
		static length

		if(!gAlive[grabbed[id]])
		{
			release(id, FLAG_GRAB)
			return
		}

		get_user_origin(id, origin, 1)
		get_user_origin(id, look, 3)
		get_user_origin(grabbed[id], grabbedorigin)

		direction[0]=look[0]-origin[0]
		direction[1]=look[1]-origin[1]
		direction[2]=look[2]-origin[2]
		length = get_distance(look,origin)
		if (!length) length=1 // avoid division by 0

		moveto[0]=origin[0]+direction[0]*grablength[id]/length
		moveto[1]=origin[1]+direction[1]*grablength[id]/length
		moveto[2]=origin[2]+direction[2]*grablength[id]/length

		velocity[0]=(moveto[0]-grabbedorigin[0])*velocity_multiplier
		velocity[1]=(moveto[1]-grabbedorigin[1])*velocity_multiplier
		velocity[2]=(moveto[2]-grabbedorigin[2])*velocity_multiplier

		fVelocity[0] = float(velocity[0])
		fVelocity[1] = float(velocity[1])
		fVelocity[2] = float(velocity[2])
		entity_set_vector(grabbed[id], EV_VEC_velocity, fVelocity)
	}
	else
	{
		get_user_aiming(id, targetid, body)
		if (IsPlayer(targetid))
		{
			set_grabbed(id, targetid)
		}
	}
}

public spec_event(id)
{
	new targetid = read_data(2)

	if (IsPlayer(targetid))
	{
		if ( (grabmodeon & (1<<(id&31))) && !grabbed[id])
		{
			set_grabbed(id, targetid)
		}
	}
}

public set_grabbed(id, targetid)
{
	new targname[32]
	get_user_name(targetid,targname,31)

	if( !(get_user_flags(id) & ADMIN_SUPREME) && (get_user_flags(targetid) & ADMIN_IMMUNITY))
	{
		client_print(id, print_chat, _T("Player ^"%s^" has immunity."), targname)
		release(id, FLAG_GRAB) // just to "brake" spam
		return
	}

	new origin1[3], origin2[3]
	get_user_origin(id, origin1)
	get_user_origin(targetid, origin2)
	new team = get_user_team(targetid)

	grabbed[id]=targetid
	grablength[id]=get_distance(origin1,origin2)

	gAlive[targetid] = true

	set_user_gravity(targetid,0.001)
	set_user_rendering(targetid,kRenderFxGlowShell,(team==1)?50:0,0,(team==1)?0:50, kRenderNormal, 30)

	client_print(id, print_chat, _T("You grabbed %s."), targname)

	#if defined USE_LOGS
	new name[32], authid[24], ip[24], targauthid[24], targip[24]
	get_user_name(id, name, 31)
	get_user_authid(id, authid, 23)
	get_user_ip(id, ip, 23, 1)
	get_user_authid(targetid, targauthid, 23)
	get_user_ip(targetid, targip, 23, 1)
	log_amx("Jedi Force Grab: ^"%s<%d><%s><%s>^" grab ^"%s<%d><%s><%s>^"",
	name, get_user_userid(id), authid, ip, targname, get_user_userid(targetid), targauthid, targip)
	#endif
}

/************************************************************************************************************************/
/****************************************************** NINJAROPE *******************************************************/
/************************************************************************************************************************/

public ropetask(id)
{
	id -= 200

	if (!gAlive[id])
	{
		RopeRelease(id)
		return
	}

	if (gBeamIsCreated[id] + BEAMLIFE/10 <= get_gametime())
	{
		beamentpoint(id)
	}

	static user_origin[3]
	static user_look[3]
	static user_direction[3]
	static move_direction[3]
	static A[3]
	static D[3]
	static buttonadjust[3]
	static acceleration
	static velocity_towards_A
	static desired_velocity_towards_A
	static velocity[3]
	static null[3]
	static buttons

	user_origin = {0, 0, 0}
	user_look = {0, 0, 0}
	user_direction = {0, 0, 0}
	move_direction = {0, 0, 0}
	A = {0, 0, 0}
	D = {0, 0, 0}
	buttonadjust = {0, 0, 0}
	acceleration = 0
	velocity_towards_A = 0
	desired_velocity_towards_A = 0
	velocity = {0, 0, 0}
	null = {0, 0, 0}

	get_user_origin(id, user_origin)
	get_user_origin(id, user_look, 2)
	kz_velocity_get(id, velocity)

	buttons = get_user_button(id)

	if (buttons&IN_FORWARD)   buttonadjust[0]+=1
	if (buttons&IN_BACK)      buttonadjust[0]-=1
	if (buttons&IN_MOVERIGHT) buttonadjust[1]+=1
	if (buttons&IN_MOVELEFT)  buttonadjust[1]-=1
	if (buttons&IN_JUMP)      buttonadjust[2]+=1
	if (buttons&IN_DUCK)      buttonadjust[2]-=1

	if (buttonadjust[0] || buttonadjust[1])
	{
		user_direction[0] = user_look[0] - user_origin[0]
		user_direction[1] = user_look[1] - user_origin[1]

		move_direction[0] = buttonadjust[0]*user_direction[0] + user_direction[1]*buttonadjust[1]
		move_direction[1] = buttonadjust[0]*user_direction[1] - user_direction[0]*buttonadjust[1]
		move_direction[2] = 0

		velocity[0] += floatround(move_direction[0] * MOVEACCELERATION * DELTA_T / get_distance(null,move_direction))
		velocity[1] += floatround(move_direction[1] * MOVEACCELERATION * DELTA_T / get_distance(null,move_direction))
	}

	if (buttonadjust[2]) gHookLenght[id] -= floatround(buttonadjust[2] * REELSPEED * DELTA_T)
	if (gHookLenght[id] < 100) gHookLenght[id] = 100

	A[0] = gHookLocation[id][0] - user_origin[0]
	A[1] = gHookLocation[id][1] - user_origin[1]
	A[2] = gHookLocation[id][2] - user_origin[2]

	D[0] = A[0]*A[2] / get_distance(null,A)
	D[1] = A[1]*A[2] / get_distance(null,A)
	D[2] = -(A[1]*A[1] + A[0]*A[0]) / get_distance(null,A)

	acceleration = -global_gravity * D[2] / get_distance(null,D)

	velocity_towards_A = (velocity[0] * A[0] + velocity[1] * A[1] + velocity[2] * A[2]) / get_distance(null,A)
	desired_velocity_towards_A = (get_distance(user_origin,gHookLocation[id]) - gHookLenght[id] /*- 10*/) * 4

	if (get_distance(null,D)>10)
	{
		velocity[0] += floatround((acceleration * DELTA_T * D[0]) / get_distance(null,D))
		velocity[1] += floatround((acceleration * DELTA_T * D[1]) / get_distance(null,D))
		velocity[2] += floatround((acceleration * DELTA_T * D[2]) / get_distance(null,D))
	}

	velocity[0] += ((desired_velocity_towards_A - velocity_towards_A) * A[0]) / get_distance(null,A)
	velocity[1] += ((desired_velocity_towards_A - velocity_towards_A) * A[1]) / get_distance(null,A)
	velocity[2] += ((desired_velocity_towards_A - velocity_towards_A) * A[2]) / get_distance(null,A)

	kz_velocity_set(id, velocity)
}

public hooktask(id)
{ 
	id -= 200

	if ( !gIsHooked[id] ) return 
	
	if (!gAlive[id])
	{
		RopeRelease(id)
		return
	}

	if (gBeamIsCreated[id] + BEAMLIFE/10 <= get_gametime())
	{
		beamentpoint(id)
	}

	static velocity[3]
	static user_origin[3]
	static oldvelocity[3]

	get_user_origin(id, user_origin) 
	kz_velocity_get(id, oldvelocity) 
	static distance
	distance = get_distance(gHookLocation[id], user_origin)
	if ( distance > 10 ) 
	{ 
		velocity[0] = floatround( (gHookLocation[id][0] - user_origin[0]) * ( 2.0 * REELSPEED / distance ) )
		velocity[1] = floatround( (gHookLocation[id][1] - user_origin[1]) * ( 2.0 * REELSPEED / distance ) )
		velocity[2] = floatround( (gHookLocation[id][2] - user_origin[2]) * ( 2.0 * REELSPEED / distance ) )
	} 
	else
	{
		velocity[0]=0
		velocity[1]=0
		velocity[2]=0
	}

	kz_velocity_set(id, velocity) 
	
} 

public hook_on(id) {
	if (gAllowedHook[id] || access(id, FLAG_HOOK)) {
		if (!gIsHooked[id] && gAlive[id]) {
			new cmd[6]
			read_argv(0,cmd,charsmax(cmd))
			if(equali(cmd,"+rope")) RopeAttach(id,0)
			else if(equali(cmd,"+hook")) RopeAttach(id,1)
		}
	}
	else {
		client_print(id, print_chat, _T("You have no access to that command."))
		return PLUGIN_HANDLED
	}
	return PLUGIN_HANDLED
}

public hook_off(id) {
	if (gAllowedHook[id] || access(id, FLAG_HOOK)) {
		if (gIsHooked[id])
			RopeRelease(id)
	}
	else {
		client_print(id, print_chat, _T("You have no access to that command."))
		return PLUGIN_HANDLED
	}
	return PLUGIN_HANDLED
}

public RopeAttach(id,hook)
{
	CheatDetect(id, "Hook/Rope")
	new user_origin[3]
	gIsHooked[id] = true
	get_user_origin(id,user_origin)
	get_user_origin(id,gHookLocation[id], 3)
	gHookLenght[id] = get_distance(gHookLocation[id],user_origin)
	global_gravity = get_cvarptr_num(g_cvar_sv_gravity)
	set_user_gravity(id,0.001)
	beamentpoint(id)
	emit_sound(id, CHAN_STATIC, "weapons/xbow_hit2.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)
	if (hook) set_task(DELTA_T, "hooktask", 200+id, _, _, "b")
	else set_task(DELTA_T, "ropetask", 200+id, _, _, "b")
}

public RopeRelease(id)
{
	gIsHooked[id] = false
	killbeam(id)
	set_user_gravity(id)
	remove_task(200+id)
}

public beamentpoint(id)
{
	message_begin( MSG_BROADCAST, SVC_TEMPENTITY )
	write_byte( TE_BEAMENTPOINT )
	write_short( id )
	write_coord( gHookLocation[id][0] )
	write_coord( gHookLocation[id][1] )
	write_coord( gHookLocation[id][2] )
	write_short( beam )	// sprite index
	write_byte( 0 )		// start frame
	write_byte( 0 )		// framerate
	write_byte( BEAMLIFE )	// life
	write_byte( 10 )	// width
	write_byte( 0 )		// noise
	if (get_user_team(id)==1)		// Terrorist
	{
		write_byte( 255 )	// r, g, b
		write_byte( 0 )	// r, g, b
		write_byte( 0 )	// r, g, b
	}
	else							// Counter-Terrorist
	{
		write_byte( 0 )	// r, g, b
		write_byte( 0 )	// r, g, b
		write_byte( 255 )	// r, g, b
	}
	write_byte( 150 )	// brightness
	write_byte( 0 )		// speed
	message_end( )
	gBeamIsCreated[id] = get_gametime()
}

public killbeam(id)
{
	message_begin( MSG_BROADCAST, SVC_TEMPENTITY )
	write_byte( TE_KILLBEAM )
	write_short( id )
	message_end()
}

/************************************************************************************************************************/
/***************************************************** NVG CONTROL ******************************************************/
/************************************************************************************************************************/

public NVGToggle(id) {
	if (get_cvarptr_num(g_cvar_kz_nightvision)<=0) return PLUGIN_CONTINUE

	if (NVGrun[id]==1) NVGcmd(id,0) 
	else NVGcmd(id,1)
	return PLUGIN_HANDLED
}

public NVGcmd(id,nvgstate) {
	message_begin(MSG_ONE, 111, {0,0,0}, id) 
	write_byte( nvgstate ) 
	message_end()
	NVGrun[id]=nvgstate
	emit_sound(id,CHAN_ITEM, NVGrun[id]?"items/nvg_on.wav":"items/nvg_off.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)
}

/************************************************************************************************************************/
/******************************************************* FORWARDS *******************************************************/
/************************************************************************************************************************/

public client_disconnect(id) {
	gConnected[id] = false
	gAlive[id] = false

	gCheckpoint[id]=false
	gJoined[id]=false

	gAllowedHook[id]=0
	ResetTimer(id,0)
}

public client_putinserver(id) {
	gConnected[id] = true
	gAlive[id] = false

	gCheckpoint[id]=false
	gJoined[id]=true

	gMoney[id]=gStartMoney
	ResetTimer(id,0)
}

public client_prethink(id) {
	if(gClimbMap && gAlive[id] && get_cvarptr_num(g_cvar_kz_bunnyjump) > 0 && entity_get_int(id, EV_INT_button) & IN_JUMP) {
		entity_set_float(id, EV_FL_fuser2, 0.0)

		static const FL_FLAGS = FL_WATERJUMP|FL_ONGROUND
		static iOldButtons

		if(entity_get_int(id, EV_INT_flags) & FL_FLAGS == FL_ONGROUND
		&& entity_get_int(id, EV_INT_waterlevel) < 2
		&& (iOldButtons = entity_get_int(id, EV_INT_oldbuttons)) & IN_JUMP) {
			entity_set_int(id, EV_INT_oldbuttons, iOldButtons & ~IN_JUMP)
		}
	}
}

public entity_touch(entity, id) {
	if(gClimbMap && entity > gMaxPlayers && IsPlayer(id) && gAlive[id] && GetEntBits(entity)) {
		if (get_cvarptr_num(g_cvar_kz_timer)>0) {
			static pToucherTarget[20]
			static pToucherTargetname[20]
			entity_get_string(entity, EV_SZ_target, pToucherTarget, charsmax(pToucherTarget))
			entity_get_string(entity, EV_SZ_targetname, pToucherTargetname, charsmax(pToucherTargetname))

			if (!gHasTimer[id] && (equal(pToucherTarget, "counter_start") || equal(pToucherTargetname, "clockstartbutton"))) {
				gHasTimer[id]=true
				client_print(id,print_chat,_T("[KZ] Timer started."))
				gCheckpoint[id]=false
			}

			if (gHasTimer[id] && !gHasStoppedTimer[id] && (equal(pToucherTarget, "counter_off") || equal(pToucherTargetname, "clockstopbutton"))) {
				static gName[33]
				gHasStoppedTimer[id]=true
				gHasTimer[id]=false
				get_user_name(id,gName,charsmax(gName))
				client_print(id,print_chat,_T("[KZ] Timer stopped."))
				if (get_cvarptr_num(g_cvar_kz_checkpoints) > 0) client_print(0,print_chat,_T("[KZ] %s just beat the map in %d:%d:%d (used %d checkpoints)."),gName,gMins[id],gSecs[id],gHuns[id],gChecks[id])
				else client_print(0,print_chat,_T("[KZ] %s just beat the map in %d:%d:%d"),gName,gMins[id],gSecs[id],gHuns[id])
				check_top15(id)
			}
		}
	}
}

/************************************************************************************************************************/
/********************************************************* TIMER ********************************************************/
/************************************************************************************************************************/

public entity_think(entity) {
	if(entity == gTimerThinker) {
		entity_set_float(entity, EV_FL_nextthink, get_gametime() + TIMER_THINK_TIME)
		static id
		for(id = 1; id <= gMaxPlayers; id++) {
			if(gConnected[id] && gHasTimer[id]) {
				gHuns[id]+=10
				if (gHuns[id] == 100) {
					gHuns[id]	= 00
					gSecs[id] += 1
				}
				if (gSecs[id] == 60) {
					gSecs[id]	= 00
					gMins[id] += 1
				}
				if (gMins[id] == 120) {
					gMins[id]	= 00
					ResetTimer(id,1)
					client_print(id,print_center, _T("[KZ] Sorry, you used too long time."))
				}
				static sMins[33],sSecs[33],sHuns[33]
				FormatTime(gMins[id],gSecs[id],gHuns[id],sMins,sSecs,sHuns)
				client_print(id,print_center,"%s:%s:%s",sMins,sSecs,sHuns)
			}
		}
	}
}

public ResetTimer(id,msg) 
{
	if (msg==1) client_print(id,print_chat,_T("[KZ] Timer reset..."))
	gHasTimer[id]=false
	gHasStoppedTimer[id]=false
	gSecs[id]=0
	gMins[id]=0
	gHuns[id]=0
	gChecks[id]=0
}

/************************************************************************************************************************/
/******************************************************* Top 15 *********************************************************/
/************************************************************************************************************************/

check_top15(id) {
	if (get_cvarptr_num(g_cvar_kz_top15)<=0)
		return

	new sPlayerScore[10],sHighScore[10]
	new sMins[33],sSecs[33],sHuns[33]
	new sMinsScore[33],sSecsScore[33],sHunsScore[33]

	FormatTime(gMins[id],gSecs[id],gHuns[id],sMins,sSecs,sHuns)
	formatex(sPlayerScore,charsmax(sPlayerScore),"%s%s%s",sMins,sSecs,sHuns)
	FormatTime(gMinsScore[14],gSecsScore[14],gHunsScore[14],sMinsScore,sSecsScore,sHunsScore)
	formatex(sHighScore,charsmax(sHighScore),"%s%s%s",sMinsScore,sSecsScore,sHunsScore)

	new iPlayerScore = str_to_num(sPlayerScore)
	new iHighScore = str_to_num(sHighScore)

	if( iPlayerScore < iHighScore) {
		new name[33],authid[24]
		get_user_name(id, name, charsmax(name))
		get_user_authid(id, authid, charsmax(authid))
		new pos
		for( new i = 0; i < 15; i++ ) {
			FormatTime(gMinsScore[i],gSecsScore[i],gHunsScore[i],sMinsScore,sSecsScore,sHunsScore)
			formatex(sHighScore,charsmax(sHighScore),"%s%s%s",sMinsScore,sSecsScore,sHunsScore)
			iHighScore = str_to_num(sHighScore)
			if(iPlayerScore < iHighScore) {
				pos = i
				while( pos < 14 && !equal( gAuthScore[pos], authid ) )
					pos++
				for( new j = pos; j > i; j-- ) {
					gAuthScore[j] = gAuthScore[j-1]
					gNameScore[j] = gNameScore[j-1]
					gMinsScore[j] = gMinsScore[j-1]
					gSecsScore[j] = gSecsScore[j-1]
					gHunsScore[j] = gHunsScore[j-1]
					gChecksScore[j] = gChecksScore[j-1]
				}

				gAuthScore[i] = authid
				gNameScore[i] = name
				gMinsScore[i] = gMins[id]
				gSecsScore[i] = gSecs[id]
				gHunsScore[i] = gHuns[id]
				gChecksScore[i] = gChecks[id]

				save_top15()
				return
			}
			if( equal( gAuthScore[i], authid ) )
				return
		}	
	}
}

save_top15() {
	if (get_cvarptr_num(g_cvar_kz_top15)<=0)
		return

	new cScoreFile[96]	
	formatex(cScoreFile, charsmax(cScoreFile), "%s/%s.txt", gScorePath, gMapName)

	if( file_exists(cScoreFile) )	
		delete_file(cScoreFile)

	new TextToSave[1024],sNameScore[33]
	for( new i = 0; i < 15; i++ ) {
		if( gMinsScore[i] == 0 && gSecsScore[i] == 0 && gHunsScore[i] == 0)
			return

		formatex(sNameScore, charsmax(sNameScore), "^"%s^"", gNameScore[i])
		formatex(TextToSave,charsmax(TextToSave),"%s %s %d %d %d %d",gAuthScore[i],sNameScore,gMinsScore[i],gSecsScore[i],gHunsScore[i],gChecksScore[i])
		write_file(cScoreFile, TextToSave)
	}
}

read_top15() {
	/*if (get_cvarptr_num(g_cvar_kz_top15)<=0)
		return*/

	for( new i = 0; i < 15; ++i) {
		gAuthScore[i] = "X"
		gNameScore[i] = "X"
		gMinsScore[i] = 9999999
		gSecsScore[i] = 0
		gHunsScore[i] = 0
		gChecksScore[i] = 9999999
	}

	new cScoreFile[96]	
	formatex(cScoreFile, charsmax(cScoreFile), "%s/%s.txt", gScorePath, gMapName)
	
	if(file_exists(cScoreFile)) { 
		new line, stxtsize 
		new data[128]
		new tName[32],tAuth[24],tMins[10],tSecs[10],tHuns[10],tChecks[10]

		while(line < 15 && (line = read_file(cScoreFile,line,data,charsmax(data),stxtsize)) != 0) {
			parse(data,tAuth,charsmax(tAuth),tName,charsmax(tName),tMins,charsmax(tMins),tSecs,charsmax(tSecs),tHuns,charsmax(tHuns),tChecks,charsmax(tChecks))
			gAuthScore[line] = tAuth
			gNameScore[line] = tName
			gMinsScore[line] = str_to_num(tMins)
			gSecsScore[line] = str_to_num(tSecs)
			gHunsScore[line] = str_to_num(tHuns)
			gChecksScore[line] = str_to_num(tChecks)
		}
	}
	else{
		log_amx(_T("[KZ] Error: Failed to load KZ scores config file (%s)."),cScoreFile)
	}
}

public show_top15( id, level ) {
	if (!access(id, level)) {
		console_print(id, _T("You have no access to that command."))
		return PLUGIN_HANDLED
	}

	if (get_cvarptr_num(g_cvar_kz_top15)<=0) {
		client_print(id,print_chat, _T("[KZ] Top15 is disabled."))
		return PLUGIN_HANDLED
	}
	
	static buffer[1536]
	new cvar_kz_checkpoints = get_cvarptr_num(g_cvar_kz_checkpoints)
	
	new len = copy( buffer, charsmax(buffer), "<table cellspacing=0 rules=all border=2 frame=border>" )
	if (cvar_kz_checkpoints>0) {
		len += copy( buffer[len], charsmax(buffer)-len, "<tr><th> # <th> Nick <th> Climb time <th> Checkpoints" )
	}
	else{
		len += copy( buffer[len], charsmax(buffer)-len, "<tr><th> # <th> Nick <th> Climb time" )
	}

	for(new i = 0; i < 15; ++i) {		
		if( gMinsScore[i] == 9999999 && gSecsScore[i] == 0 && gHunsScore[i] == 0 && gChecksScore[i] == 9999999) {
			if (cvar_kz_checkpoints>0) {
				len += formatex( buffer[len], charsmax(buffer)-len, "<tr><td> %d. <td> %s <td> %s <td> %s", (i+1), "&lt;----------&gt;", "&lt;not set&gt;", "&lt;not set&gt;" )
			}
			else{
				len += formatex( buffer[len], charsmax(buffer)-len, "<tr><td> %d. <td> %s <td> %s", (i+1), "&lt;----------&gt;", "&lt;not set&gt;" )
			}
		}
		else {
			if (cvar_kz_checkpoints>0) {
				len += formatex( buffer[len], charsmax(buffer)-len, "<tr><td> %d. <td> %s <td> (%d:%d:%d) <td> (%d)", (i+1), gNameScore[i], gMinsScore[i] , gSecsScore[i], gHunsScore[i], gChecksScore[i]	)
			}
			else{
				len += formatex( buffer[len], charsmax(buffer)-len, "<tr><td> %d. <td> %s <td> (%d:%d:%d)", (i+1), gNameScore[i], gMinsScore[i] , gSecsScore[i], gHunsScore[i]	)			
			}
		}
	}
	
	len += copy( buffer[len], charsmax(buffer)-len, "</table>" )
	
	show_motd( id, buffer, "Top 15 Climbers" )	
	return PLUGIN_HANDLED
}
